UPROPERTY(EditAnywhere, Category = "Shake")
float ShakeIntensity;

UPROPERTY(EditAnywhere, Category = "Shake")
float ShakeFrequency;

UPROPERTY(EditAnywhere, Category = "Shake")
float ShakeDuration;
void AYourActor::StartShake()
{
    TArray<FShakeAnimation> ShakeAnimations;

    FVector OriginalLocation = GetActorLocation();
for (int32 i = 0; i < ShakeDuration; i++)
    {
        FShakeAnimation ShakeAnimation;
        ShakeAnimation.LocationDelta = FVector(
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity)
        );
        ShakeAnimation.RotationDelta = FRotator(
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity)
        );
        ShakeAnimations.Add(ShakeAnimation);
    }
float ShakeTime = 0;
    while (ShakeTime < ShakeFrequency)
    {
        int32 ShakeIndex = FMath::RoundToInt(ShakeTime);
        if (ShakeIndex >= ShakeAnimations.Num())
        {
            break;
        }

        FVector LocationDelta = ShakeAnimations[ShakeIndex].LocationDelta;
        FRotator RotationDelta = ShakeAnimations[ShakeIndex].RotationDelta;

        SetActorLocation(OriginalLocation + LocationDelta);
        SetActorRotation(GetActorRotation() + RotationDelta);

        ShakeTime += GetWorld()->DeltaTimeSeconds;
        UGameplayStatics::GetPlayerController(GetWorld(), 0)->PlayerCameraManager->UpdateCameraShake(CameraShake, GetWorld()->DeltaTimeSeconds);
    }
SetActorLocation(OriginalLocation);
    SetActorRotation(OriginalRotation);
}

float LastInputTime;
void AYourActor::InputEvent()
{
    if (GetWorld()->GetTimeSeconds() - LastInputTime > 0.5f)
LastInputTime = GetWorld()->GetTimeSeconds();
    }
}

UPROPERTY(EditAnywhere, Category = "Aim Assist")
float AimAssistRange;

UPROPERTY(EditAnywhere, Category = "Aim Assist")
float AimAssistStrength;

UPROPERTY(EditAnywhere, Category = "Aim Assist")
TSubclassOf<AActor> AimAssistTargetClass;
AActor* AYourActor::GetAimAssistTarget()
{
    TArray<AActor*> Actors;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), AimAssistTargetClass, Actors);
float MinDistance = AimAssistRange;
    AActor* Target = nullptr;

    for (AActor* Actor : Actors)
    {
        float Distance = FVector::Distance(GetActorLocation(), Actor->GetActorLocation());
if (Distance < MinDistance)
        {
            MinDistance = Distance;
            Target = Actor;
        }
    }

    return Target;
}

void AYourActor::Tick(float DeltaSeconds)
{
    AActor* Target = GetAimAssistTarget();

    if (Target != nullptr)
    {
        FVector TargetDirection = Target->GetActorLocation() - GetActorLocation();
        TargetDirection.Normalize();

        FVector CameraForward = CameraComponent->GetForwardVector();
        CameraForward.Normalize();
FRotator LookRotation = TargetDirection.Rotation() - CameraForward.Rotation();
        LookRotation.Pitch = FMath::Clamp(LookRotation.Pitch, -AimAssistStrength, AimAssistStrength);
        LookRotation.Yaw = FMath::Clamp(LookRotation.Yaw, -AimAssistStrength, AimAssistStrength);
        SetActorRotation(GetActorRotation() + LookRotation);
    }
}

bool AYourActor::IsSaveFileValid()
{
    FString SaveFilePath = FPaths::ProjectSavedDir() + TEXT("SaveFile.sav");
    return FPlatformFileManager::Get().GetPlatformFile().FileExists(*SaveFilePath);
}

void AYourActor::BeginPlay()
{
    Super::BeginPlay();

    if (!IsSaveFileValid())
    {

void AYourActor::SetNetworkParameters()
{
    GetWorldSettings()->MaxTickRate = 60.0f;
GetWorldSettings()->bHighPriorityLoadingForLoadMap = true;
void AYourPlayerController::SetNetworkParameters()
{
    SetInputMode(FInputModeGameAndUI());
bShowMouseCursor = false;
SetReplicates(false);
    bAlwaysRelevant = true;
    bOnlyRelevantToOwner = true;
bNetUseOwnerRelevancy = true;
}

void AYourActor::SetOptimizationSettings()
{
    SetActorEnableCollision(false);
SetRenderCustomDepth(true);
SetReplicates(false);
SetHiddenInGame(true);
SetCanBeDamaged(false);

void AYourActor::SetOptimizationSettings()
{
SetRenderCustomDepth(true);
    CustomDepthStencilValue = 1;
SetReplicates(false);
    bAlwaysRelevant = true;
    bOnlyRelevantToOwner = true;
    bNetUseOwnerRelevancy = true;
}

void AYourActor::SetFrameRateLimit()
{
    SetActorTickEnabled(true);
    PrimaryActorTick.bCanEverTick = true;
    PrimaryActorTick.TickInterval = 1/90.0f;
}  

void AYourActor::ApplyDamageToTarget(AActor* TargetActor, float DamageAmount)
{
FVector ShooterLocation = GetActorLocation();
    FVector TargetLocation = TargetActor->GetActorLocation();
float ShotDistance = FVector::Dist(ShooterLocation, TargetLocation);
UWorldSettings* WorldSettings = GetWorld()->GetWorldSettings();
float MaxShotDistance = WorldSettings->MaxShotDistance;
if (ShotDistance > MaxShotDistance)
    {
        return;
    }          
TargetActor->TakeDamage(DamageAmount, FDamageEvent(), NULL, this);
}
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "CoverSystem.generated.h"

UCLASS()
class YOURPROJECT_API ACoverSystem : public AActor
{
    GENERATED_BODY()

public: 
    ACoverSystem();

protected:
    virtual void BeginPlay() override;

public: 
    virtual void Tick(float DeltaTime) override;

    UFUNCTION(BlueprintCallable)
    void CheckCoverHit(AActor* Shooter, AActor* Target, FVector ShootDirection);

private:
    float CoverCheckDistance = 1000.f;
    float CoverCheckRadius = 50.f;
};
#include "CoverSystem.h"
#include "DrawDebugHelpers.h"
#include "Kismet/GameplayStatics.h"

ACoverSystem::ACoverSystem()
{
    PrimaryActorTick.bCanEverTick = true;
}

void ACoverSystem::BeginPlay()
{
    Super::BeginPlay();
}

void ACoverSystem::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
}

void ACoverSystem::CheckCoverHit(AActor* Shooter, AActor* Target, FVector ShootDirection)
{
    FHitResult HitResult;
    FVector StartTrace = Target->GetActorLocation();
    FVector EndTrace = StartTrace + ShootDirection * CoverCheckDistance;

    FCollisionQueryParams TraceParams(FName(TEXT("CoverCheck")), true, Shooter);
    TraceParams.bReturnPhysicalMaterial = true;

    if (GetWorld()->LineTraceSingleByChannel(HitResult, StartTrace, EndTrace, ECC_Visibility, TraceParams))
    {
        // Check if the hit actor is the target
        if (HitResult.GetActor() == Target)
        {
            // Apply damage to the target
            float DamageAmount = 10.f;
            UGameplayStatics::ApplyDamage(Target, DamageAmount, nullptr, Shooter, nullptr);
        }
    }
}
AActor::AActor(const FObjectInitializer& ObjectInitializer)
    : Super(ObjectInitializer.SetDefaultSubobjectClass<UCapsuleComponent>(ACharacter::CapsuleComponentName))
{
Cover
    GetCapsuleComponent()->SetCollisionProfileName(TEXT("Cover"));  
    void YourCharacterClass::ApplyDamage(float DamageAmount)
{
if (DamageAmount >= MaxDamageThreshold)
    {  
    #include "GridDamageActor.h"

AGridDamageActor::AGridDamageActor()
{
    PrimaryActorTick.bCanEverTick = true;

    MeshComponent = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("MeshComponent"));
    RootComponent = MeshComponent;

    MeshComponent->OnComponentHit.AddDynamic(this, &AGridDamageActor::OnMeshHit);

    DamageAmount = 10.0f;
}

void AGridDamageActor::BeginPlay()
{
    Super::BeginPlay();
    
}

void AGridDamageActor::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);

}

void AGridDamageActor::OnMeshHit(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit)
{
    if (OtherActor && OtherActor != this)
    {
        OtherActor->TakeDamage(DamageAmount, FDamageEvent(), GetInstigatorController(), this);
    }
}
void AYourPlayerCharacter::BeginPlay()
{
    Super::BeginPlay();

    GetWorldTimerManager().SetTimer(TimerHandle_Damage, this, &AYourPlayerCharacter::InflictDamage, DamageInterval, true);
}

void AYourPlayerCharacter::InflictDamage()
{
AMyCharacter::AMyCharacter()
{UCapsuleComponent* CollisionCapsule = GetCapsuleComponent();
    CollisionCapsule->SetCollisionProfileName(TEXT("CustomLyingDown"));
    CollisionCapsule->SetCapsuleHalfHeight(50.0f);
    CollisionCapsule->SetCapsuleRadius(30.0f);
    UPROPERTY(EditAnywhere, Category = "HitDetection")
float MaxHitRange;
AActor::AActor()
{
GetCollision()->SetCollisionProfileName(TEXT("OverlapAll"));
}
#include "CircleDamageRate.h"

// Sets default values
ACircleDamageRate::ACircleDamageRate()
{
    // Set this actor to call Tick() every frame
    PrimaryActorTick.bCanEverTick = true;
}

// Called when the game starts or when spawned
void ACircleDamageRate::BeginPlay()
{
    Super::BeginPlay();
}

// Called every frame
void ACircleDamageRate::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
}

void ACircleDamageRate::ApplyDamageInCircle(const FVector& Center)
{
    // Find all actors within the radius from the center
    TArray<AActor*> ActorsInRadius;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), AActor::StaticClass(), ActorsInRadius);

    for (AActor* Actor : ActorsInRadius)
    {
        if (FVector::Dist(Actor->GetActorLocation(), Center) <= Radius)
        {
            // Apply damage to the actor based on the damage rate
            // You can implement your own damage logic here
            Actor->TakeDamage(DamageRate, FDamageEvent(), nullptr, this);
        }
    }
}

void YourActorClass::YourFunctionToCheckBoundingBoxSize()
{
UBoxComponent* BoxComponent = Cast<UBoxComponent>(RootComponent);
if (BoxComponent)
    {
    FVector BoxExtent = BoxComponent->GetScaledBoxExtent();
    if (BoxExtent.X >= 100.f && BoxExtent.Y >= 100.f && BoxExtent.Z >= 100.f)
        {
        AActor* MyOwner = GetOwner();
   UWorld* World = MyOwner->GetWorld();

   FHitResult HitResult;
   FCollisionQueryParams CollisionParams;
   FVector TraceStart = MyOwner->GetActorLocation();
   FVector TraceEnd = TraceStart + MyOwner->GetActorForwardVector() * 9999.f;

   if (World->LineTraceSingleByProfile(HitResult, TraceStart, TraceEnd, "Projectile", CollisionParams))
   {
   void AYourActor::ConvertHitboxToLeftLean()
{
void AYourActor::BeginPlay()
{
    Super::BeginPlay();

    UInputComponent* InputComponent = FindComponentByClass<UInputComponent>();
    if (InputComponent)
    {
        InputComponent->BindAction("Action_Move_LeftToLeftLean", IE_Pressed, this, &AYourActor::ConvertHitboxToLeftLean);
    }
}
#include "YourActor.h"
#include "Components/StaticMeshComponent.h"
#include "Kismet/GameplayStatics.h"
#include "Math/UnrealMathUtility.h"

AYourActor::AYourActor()
{
MeshComponent = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("MeshComponent"));
    RootComponent = MeshComponent;
    TargetActor = nullptr;
}

void AYourActor::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);

    if (TargetActor)
    {
    TargetActor = nullptr;
}

void AYourActor::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);

    if (TargetActor)
    {
    FVector CurrentLocation = GetActorLocation();
        FVector TargetLocation = TargetActor->GetActorLocation();
        FRotator TargetRotation = FRotationMatrix::MakeFromX(TargetLocation - CurrentLocation).Rotator();
        FRotator NewRotation = FMath::RInterpTo(GetActorRotation(), TargetRotation, DeltaTime, 5.0f);
        SetActorRotation(NewRotation);
    }
}
void AMyActor::BeginPlay()
{
    Super::BeginPlay();

    // Disable unused features
    GetWorldSettings()->bPrecomputeVisibility = false;
    GetWorldSettings()->VisibilityRounds = 1;
    GetWorldSettings()->bForceNoPrecomputedLighting = true;

    // Adjust shadow settings
    UEngine* Engine = GetWorld()->GetGameInstance()->GetEngine();
    Engine->bSmoothFrameRate = true;
    Engine->bEnableAsyncScene = true;
    Engine->bDisableTextureStreaming = true;
    Engine->bForceCPUAccessToGPUSkinVerts = true;
}
UPrimitiveComponent* PrimitiveComp = GetMesh();
if (PrimitiveComp)
{
    FCollisionResponseContainer ResponseContainer = PrimitiveComp->GetCollisionResponseToChannels();
    ResponseContainer.SetResponse(ECollisionChannel::ECC_Visibility, ECR_Block);
    PrimitiveComp->SetCollisionResponseToChannels(ResponseContainer);
}
MEActor* TargetEnemytrue=Max;