#include "Engine/Engine.h"
#include "Animation/AnimMontage.h"
UAnimMontage* GetSpecifiedSlotAnimation(const FString& SlotName)
{
    if (UAnimMontage* AnimMontage = Cast<UAnimMontage>(GEngine->ForceLoadObject(UAnimMontage::StaticClass(), *SlotName)))
    {
        return AnimMontage;
    }

    return nullptr;
}
void SetSpecifiedSlotProperties(const FString& SlotName, const FString& SlotFriendlyName, bool bIsPlaying)
{
    if (UAnimMontage* AnimMontage = GetSpecifiedSlotAnimation(SlotName))
    {
        AnimMontage->SlotName = FName(*SlotName);
        AnimMontage->Slot_FriendlyName = FText::FromString(SlotFriendlyName);
        AnimMontage->bPlaying = bIsPlaying;
    }
}