UPROPERTY(EditAnywhere, Category = "Character")
float AutoShootDelay;
FTimerHandle AutoShootTimerHandle;

void AYourCharacter::StartAutoShoot()
{
    GetWorldTimerManager().SetTimer(AutoShootTimerHandle, this, &AYourCharacter::AutoShoot, AutoShootDelay, true);
}

void AYourCharacter::StopAutoShoot()
{
    GetWorldTimerManager().ClearTimer(AutoShootTimerHandle);
}

void AYourCharacter::AutoShoot()
{
Fire();
}

UPROPERTY(EditAnywhere, Category = "Character")
bool bIgnoreKnockback;
void AYourCharacter::TakeHit()
{
    if (!bIgnoreKnockback)
    {
Health -= Damage;
        ApplyKnockback();
    }
    else
    {
    
UCLASS()
class YOURGAME_API AYourCharacter : public ACharacter
{
    GENERATED_BODY()

public:
    // Declare the range for auto targeting
    UPROPERTY(EditAnywhere, Category=AutoTargeting)
    float AutoTargetingRange;

    // Declare the function for auto targeting
    UFUNCTION(BlueprintCallable, Category=AutoTargeting)
    AActor* AutoTargetingFunction();
};

AActor* AYourCharacter::AutoTargetingFunction()
{
    TArray<AActor*> FoundActors;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), AYourTargetClass::StaticClass(), FoundActors);

    AActor* BestTarget = nullptr;
    float BestDistance = AutoTargetingRange;

    for (AActor* Target : FoundActors)
    {
        float Distance = FVector::Dist(Target->GetActorLocation(), GetActorLocation());
        if (Distance < BestDistance)
        {
            BestTarget = Target;
            BestDistance = Distance;
        }
    }

    return BestTarget;
}

#include "GameFramework/Actor.h"
#include "Components/SphereComponent.h"
USphereComponent* SphereComponent = CreateDefaultSubobject<USphereComponent>(TEXT("SphereComponent"));
RootComponent = SphereComponent;
SphereComponent->SetSphereRadius(50.0f);
SphereComponent->SetCollisionEnabled(ECollisionEnabled::QueryAndPhysics);
SphereComponent->SetCollisionResponseToAllChannels(ECR_Block);
if(ButtonPressed == EKeys::LeftMouseButton)
    {
    
UPROPERTY(EditAnywhere, Category = "Character")
float ChestRange;

void ApplyChestDamage(float DamageAmount);
void ACharacter::ApplyChestDamage(float DamageAmount)
{
FVector ChestLocation = GetMesh()->GetSocketLocation("ChestSocket");
TArray<ACharacter*> CharactersInRange;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), ACharacter::StaticClass(), CharactersInRange);

    for (ACharacter* Character : CharactersInRange)
    {
float DistanceToChest = FVector::Distance(Character->GetActorLocation(), ChestLocation);

        if (DistanceToChest <= ChestRange)
        {
Character->TakeDamage(DamageAmount, FDamageEvent(), nullptr, this);
        }
    }
}            
    
USceneComponent* RootComponent = GetRootComponent();
if (RootComponent != nullptr)
{
UPrimitiveComponent* CollisionComponent = Cast<UPrimitiveComponent>(RootComponent);
    if (CollisionComponent != nullptr)
    {
FVector NewBoxExtent = FVector(500.f, 100.f, 250.f);
        CollisionComponent->SetBoxExtent(NewBoxExtent);
        CollisionComponent->UpdateBounds();
    }
}

#include "YourCharacterClass.h"
#include "Engine.h"

void AYourCharacterClass::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
if (GetCharacterMovement()->IsFalling() && bEnableParachuteLanding)
    {
        float CharacterSpeed = GetVelocity().Size();
if (CharacterSpeed > ParachuteSpeedThreshold)
        {
UGameplayStatics::PlaySound2D(this, ParachuteLandingSound);
PlayAnimMontage(ParachuteLandingAnimation);
GetCharacterMovement()->StopMovementImmediately();
        }
    }
}

UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = Camera, meta = (AllowPrivateAccess = "true"))
class UCameraComponent* ThirdPersonCameraComponent;
ConstructorHelpers::FObjectFinder<UCameraComponent> CameraComponent(TEXT("CameraComponent"));
if (CameraComponent.Succeeded())
{
    ThirdPersonCameraComponent = CameraComponent.Object;
}
ThirdPersonCameraComponent->AttachToComponent(GetCapsuleComponent(), FAttachmentTransformRules::KeepRelativeTransform);
ThirdPersonCameraComponent->SetRelativeLocation(FVector(-250.0f, 0.0f, 250.0f));
ThirdPersonCameraComponent->bUsePawnControlRotation = true;
void AMyCharacter::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
    UpdateCamera(DeltaTime);
}

void AMyCharacter::UpdateCamera(float DeltaTime)
{
    if (!Controller || !ThirdPersonCameraComponent) return;

    FRotator NewRotation = Controller->GetControlRotation();
    FRotator NewZoomRotation = PlayerCameraManager->GetCameraRotation();

    ThirdPersonCameraComponent->SetWorldRotation(NewRotation);
    PlayerCameraManager->SetCameraRotation(NewZoomRotation);
}

UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = Camera, meta = (AllowPrivateAccess = "true"))
class UCameraComponent* FirstPersonCameraComponent;
ConstructorHelpers::FObjectFinder<UCameraComponent> CameraComponent(TEXT("CameraComponent"));
if (CameraComponent.Succeeded())
{
    FirstPersonCameraComponent = CameraComponent.Object;
}
FirstPersonCameraComponent->AttachToComponent(GetCapsuleComponent(), FAttachmentTransformRules::KeepRelativeTransform);
FirstPersonCameraComponent->SetRelativeLocation(FVector(0.0f, 0.0f, 50.0f));
FirstPersonCameraComponent->bUsePawnControlRotation = true;
void AMyCharacter::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
    UpdateCamera(DeltaTime);
}

void AMyCharacter::UpdateCamera(float DeltaTime)
{
    if (!Controller || !FirstPersonCameraComponent) return;

    FRotator NewRotation = Controller->GetControlRotation();

    FirstPersonCameraComponent->SetWorldRotation(NewRotation);
}
float AYourCharacterClassName::TakeDamage(float DamageAmount, FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
    float ActualDamage = Super::TakeDamage(DamageAmount, DamageEvent, EventInstigator, DamageCauser);

    if (ActualDamage > 0.f)
    {
    float MaxDamage = 100.f;
        float MinDamage = 10.f;
        ActualDamage = FMath::Clamp(ActualDamage, MinDamage, MaxDamage);
        return ActualDamage;
}                                        
HandleHeadshotDamagefunction
void AYourCharacterClass::HandleHeadshotDamage(float DamageAmount, FVector HitFromDirection)
{
  if (Determine whether it is a condition for a head blow, such as hitting the head ) 
    {
        DamageAmount *= 2;
        TakeDamage(DamageAmount, FDamageEvent(), GetController(), this);
}                                        
#include "Character.h"

AYourCharacter::AYourCharacter()
{
    MaxDamage = 100.0f;
}

float AYourCharacter::GetMaxDamage() const
{
    return MaxDamage;
}
void AYourCharacter::ApplyDamage(float DamageAmount)
{
    float ActualDamage = FMath::Clamp(DamageAmount, 0.0f, MaxDamage);
}                                        
void AYourCharacterClass::BeginPlay()
{
    Super::BeginPlay();

    if (GetCapsuleComponent())
    {
        GetCapsuleComponent()->SetCapsuleSize(StandupCollisionRadius, GetCapsuleComponent()->GetScaledCapsuleHalfHeight());
    }
}
void AYourCharacterClass::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
    Super::SetupPlayerInputComponent(PlayerInputComponent);
    PlayerInputComponent->BindAction("Aim", IE_Pressed, this, &AYourCharacterClass::StartAiming);
    PlayerInputComponent->BindAction("Aim", IE_Released, this, &AYourCharacterClass::StopAiming);
}

void AYourCharacterClass::StartAiming()
{
    bIsAiming = true;
    GetCharacterMovement()->RotationRate.Yaw = 999.0f; 
}

void AYourCharacterClass::StopAiming()
{
    bIsAiming = false;
    GetCharacterMovement()->RotationRate.Yaw = 360.0f;
}
float MaxBulletSpeed = GetDefault<UYourGameModeNameConfig>()->MaxBulletSpeed;
void AYourCharacterClass::InitRecoilSettings()
{
bEnableAimDownSightsRecoilMinimization = FConfigCacheIni::LoadBooleanConfigFileValue(TEXT("Recoil"), TEXT("bEnableAimDownSightsRecoilMinimization"), false, GGameIni);
    RecoilMinimizationMultiplier = FConfigCacheIni::LoadFloatConfigFileValue(TEXT("Recoil"), TEXT("RecoilMinimizationMultiplier"), 1.0f, GGameIni);
}
void AYourCharacterClass::HandleRecoil()
{
    FVector RecoilDirection = CalculateRecoilDirection();
    float RecoilStrength = CalculateRecoilStrength();
    if (bEnableAimDownSightsRecoilMinimization && bIsAimingDownSights)
    {
        RecoilStrength *= RecoilMinimizationMultiplier;
        ApplyRecoilForce(RecoilDirection, RecoilStrength);
        const float HeadshotDamageMultiplier = 2.0f;
        void AMyCharacter::TakeDamage(float DamageAmount, FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
    Super::TakeDamage(DamageAmount, DamageEvent, EventInstigator, DamageCauser);
    if (DamageEvent.IsOfType(FPointDamageEvent::ClassID))
    {
        FPointDamageEvent* PointDamageEvent = (FPointDamageEvent*)&DamageEvent;
        
        if (PointDamageEvent->HitInfo.BoneName == FName("head"))
        {
        DamageAmount *= HeadshotDamageMultiplier;
        }
    }
    void YourCharacterClass::ServerNotifyHit_Implementation(FHitResult HitResult)
{
}
bool YourCharacterClass::ServerNotifyHit_Validate(FHitResult HitResult)
{
return true;
}
void YourCharacterClass::HandleShot()
{
FHitResult HitResult;
if (Role < ROLE_Authority)
    {
        ServerNotifyHit(HitResult);
    }
}
bReplicates = true;
bReplicateMovement = true;
NetUpdateFrequency = 100.0f;
float CalculateFinalDamage(float BaseDamage, float ArmorValue)
{
    float FinalDamage = BaseDamage * (1.0f - ArmorValue);
    if (FinalDamage < 0.0f)
    {
        FinalDamage = 0.0f;
    }
    
    return FinalDamage;
}
void ApplyDamage(Character* TargetCharacter, float BaseDamage)
{
float ArmorValue = TargetCharacter->GetArmorValue();
float FinalDamage = CalculateFinalDamage(BaseDamage, ArmorValue);
TargetCharacter->TakeDamage(FinalDamage);
}
AACharacter::AACharacter()
{
    AimingSpreadIncreaseRate = 0.1f;
    void AMyCharacter::PostNetReceivePhysicState()
{
    Super::PostNetReceivePhysicState();
    if (GetLocalRole() == ROLE_SimulatedProxy)
    {
        ClientTimeStamp = FPlatformTime::Seconds();
    }
}
void AMyCharacter::OnReceiveRepData()
{
    if (GetLocalRole() == ROLE_AutonomousProxy)
void AMyCharacter::AdjustDamage(float DamageAmount)
{
    const float PredictionTime = 0.1f;
    const float PredictionDamage = GetPredictedDamage(DamageAmount, PredictionTime);
    if (GetLocalRole() == ROLE_AutonomousProxy)
    {
        TakeDamage(PredictionDamage, FDamageEvent, DamageInstigator, DamageCauser);
    }
    if (GetLocalRole() == ROLE_SimulatedProxy)
    {
        const float InterpolatedDamage = FMath::Lerp(LastDamageAmount, PredictionDamage, 0.5f);
        LastDamageAmount = InterpolatedDamage;
        TakeDamage(InterpolatedDamage, FDamageEvent, DamageInstigator, DamageCauser);
    }
}
float AMyCharacter::GetPredictedDamage(float DamageAmount, float PredictionTime)
{
    return DamageAmount;
}
AMyCharacter::AMyCharacter()
{
    GetCapsuleComponent()->SetCapsuleHalfHeight(100.0f);
    
void AYourCharacterClass::BeginPlay()
{
    Super::BeginPlay();

    UGameUserSettings* GameUserSettings = GetGameUserSettings();
    if (GameUserSettings)
    {
        GameUserSettings->SetDisableForceFeedback(false);
        GameUserSettings->SetAxisConfigValue(EForceFeedbackChannel::TYPE_Channel, false, 1.0f);
        GameUserSettings->SetAxisConfigValue(EForceFeedbackChannel::TYPE_Channel2, false, 1.0f);
    }
}    
void AYourCharacter::BP_Fire()
{
APlayerController* PlayerController = Cast<APlayerController>(GetController());

    if (PlayerController != nullptr)
    {
    FVector CameraLocation;
        FRotator CameraRotation;
        PlayerController->GetPlayerViewPoint(CameraLocation, CameraRotation);
        FHitResult HitResult;
        FCollisionQueryParams TraceParams(FName(TEXT("FireTrace")), true, this);
        FVector StartTrace = CameraLocation;
        FVector EndTrace = CameraLocation + (CameraRotation.Vector() * 10000.0f);
        GetWorld()->LineTraceSingleByChannel(HitResult, StartTrace, EndTrace, ECollisionChannel::ECC_GameTraceChannel1, TraceParams);

        if (HitResult.bBlockingHit)
        {
        if (HitResult.BoneName == FName("head"))
            {
            }
        }
    }
}
CharacterMesh->BodyInstance.SetBodyScale(Scale);
CharacterMesh->BodyInstance.SetInstanceCollisionProfileName(TEXT("PhysicsActor")); 
#include "MyPlayerCharacter.h"
#include "MyEnemyCharacter.h"
void AMyPlayerCharacter::ShootEnemy(AMyEnemyCharacter* Enemy)
{
    float Distance = FVector::Distance(GetActorLocation(), Enemy->GetActorLocation());
    float Damage = 0.0f;
    if (Distance > 80.0f) 
    {
        Damage = 50.0f;
    } 
    else if (Distance > 100.0f) 
    {
        Damage = 9999.0f;
    } 
    else 
    {
        Damage = 9999.0f;
    }
    Enemy->TakeDamage(Damage, FDamageEvent(), GetController(), this);
}
void AMyCharacter::DealDamageToEnemy(AActor* Enemy)
{
    if (Enemy)
    {
        FVector Location = GetActorLocation();
        FVector EnemyLocation = Enemy->GetActorLocation();
        float Distance = FVector::Distance(Location, EnemyLocation);

        if (Distance <= 50.0f)
        {
        Enemy->TakeDamage(9999, DamageParams, InstigatedBy, this);
        }
    }
}