#include "YourClass.h"
#include "Containers/Array.h"
#include "Math/NumericLimits.h"

AYourClass::AYourClass()
{
    TotalDamage = CalculateMaxDamage();
}

float AYourClass::CalculateMaxDamage()
{
    TArray<float> DamageArray = { 10.0f, 20.0f, 15.0f, 30.0f }; // Example damage values

    if(DamageArray.Num() == 0)
    {
        return 0.0f;
    }

    float MaxDamage = TNumericLimits<float>::Lowest();

    for(float Damage : DamageArray)
    {
        if(Damage > MaxDamage)
        {
            MaxDamage = Damage;
        }
    }

    return MaxDamage;
}
AGameNetworkManager* GameNetworkManager = GetWorld()->GetGameNetworkManager();

if (GameNetworkManager)
{
    GameNetworkManager->TotalNetBandwidth = 1000000;
    GameNetworkManager->MaxDynamicBandwidth = 1000000;
    GameNetworkManager->MinDynamicBandwidth = 1000000;
}
void UYourClass::Init()
{
    GEngine->SetShouldTickAnimation(false);
    GEngine->SetShouldUpdateBoneTransforms(false);
}
FVector ConvertRightSkewedHitBoxToUE4Coordinate(const FVector& hitboxPosition, const FVector& hitboxExtent)
{
float ScreenWidth = 1920.0f;
    float ScreenHeight = 1080.0f;
    float X = hitboxPosition.X;
    float Y = hitboxPosition.Y;
    float newX = X - ScreenWidth / 2.0f;
    float newY = ScreenHeight / 2.0f - Y;
    FVector ue4Position = FVector(newX, newY, hitboxPosition.Z);
    FVector ue4Extent = FVector(hitboxExtent.X, hitboxExtent.Y, hitboxExtent.Z);
    
    return ue4Position;
}