UCLASS()
class YOURPROJECT_API AGun : public AActor
{
    GENERATED_BODY()

public:
    UPROPERTY(EditDefaultsOnly, Category = "Gun")
    float FireRate;
    UPROPERTY(EditDefaultsOnly, Category = "Gun")
    UParticleSystem* FireEffect;
    UPROPERTY(EditDefaultsOnly, Category = "Gun")
    USoundBase* FireSound;
    UPROPERTY(EditDefaultsOnly, Category = "Gun")
    int32 AmmoCapacity;
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Gun")
    int32 CurrentAmmo;
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Gun")
    bool bCanFire;
public:
    UFUNCTION(BlueprintCallable, Category = "Gun")
    void Fire();
    UFUNCTION(BlueprintCallable, Category = "Gun")
    void UseAmmo();
    UFUNCTION(BlueprintCallable, Category = "Gun")
    void SetCanFire(bool CanFire);
protected:
    virtual void BeginPlay() override;
    FTimerHandle FireTimerHandle;
    bool bIsFiring;
};
void AGun::BeginPlay()
{
    Super::BeginPlay();
    CurrentAmmo = AmmoCapacity;
    bCanFire = true;
}
void AGun::Fire()
{
    if (!bCanFire || CurrentAmmo <= 0 || bIsFiring)
    {
        return;
    }
    UGameplayStatics::SpawnEmitterAttached(FireEffect, RootComponent);
    UGameplayStatics::PlaySoundAtLocation(this, FireSound, GetActorLocation());
    UseAmmo();
    SetCanFire(false);
    GetWorld()->GetTimerManager().SetTimer(FireTimerHandle, this, &AGun::SetCanFire, FireRate, false);
}
void AGun::UseAmmo()
{
    CurrentAmmo--;
}
void AGun::SetCanFire(bool CanFire)
{
    bCanFire = CanFire;
}
UCLASS()
class YOURGAME_API AWeapon : public AActor
{
    GENERATED_BODY()

public:
    AWeapon();
    
    UPROPERTY(EditDefaultsOnly, Category = "Weapons")
    EWeaponType WeaponType;
};
void FireGun()
{
FVector CurrentVelocity = GetActorForwardVector() * GunSpeedMultiplier;