#include "HardAimAssistSettings.h"
#include "Engine/Engine.h"
#include "GameFramework/GameUserSettings.h"
#include "HAL/FileManagerGeneric.h"
#include "Misc/Paths.h"
#include "HAL/PlatformFilemanager.h"

bool UHardAimAssistSettings::LoadConfig()
{
    FString ConfigFilePath = FPaths::ProjectConfigDir() + "/HardAimAssistSettings.ini";
    FConfigCacheIni::LoadExternalIniFile(ConfigFilePath);

    const FString SectionName = TEXT("/Script/YourGame.HardAimAssistSettings");

    // Load configuration values
    GConfig->GetBool(*SectionName, TEXT("bEnableHardAimAssist"), bEnableHardAimAssist, ConfigFilePath);
    GConfig->GetFloat(*SectionName, TEXT("fHardAimAssistSensitivity"), fHardAimAssistSensitivity, ConfigFilePath);
    GConfig->GetFloat(*SectionName, TEXT("fHardAimAssistRange"), fHardAimAssistRange, ConfigFilePath);
    GConfig->GetFloat(*SectionName, TEXT("fHardAimAssistMaxAngleOffset"), fHardAimAssistMaxAngleOffset, ConfigFilePath);

    return true;
}

bool UHardAimAssistSettings::SaveConfig()
{
    // Save configuration values to .ini file
    FString ConfigFilePath = FPaths::ProjectConfigDir() + "/HardAimAssistSettings.ini";
    FConfigCacheIni::SetString(ConfigFilePath, TEXT("/Script/YourGame.HardAimAssistSettings"), TEXT("bEnableHardAimAssist"), bEnableHardAimAssist ? TEXT("True") : TEXT("False"));
    FConfigCacheIni::SetFloat(ConfigFilePath, TEXT("/Script/YourGame.HardAimAssistSettings"), TEXT("fHardAimAssistSensitivity"), fHardAimAssistSensitivity);
    FConfigCacheIni::SetFloat(ConfigFilePath, TEXT("/Script/YourGame.HardAimAssistSettings"), TEXT("fHardAimAssistRange"), fHardAimAssistRange);
    FConfigCacheIni::SetFloat(ConfigFilePath, TEXT("/Script/YourGame.HardAimAssistSettings"), TEXT("fHardAimAssistMaxAngleOffset"), fHardAimAssistMaxAngleOffset);

    return true;
}