void AMyCharacter::OnAttack()
{
float DamageAmount = BaseDamage * BodyDamageMultiplier;
ApplyDamage(DamageAmount, DamageEvent, InstigatedByController, this);
}
AMyCharacter::AMyCharacter()
{
    RecoilForce = FVector2D(0.0f, 1000.0f);
}
void AMyCharacter::AddRecoil()
{
    USkeletalMeshComponent* MeshComp = GetMesh();
    if (MeshComp)
    {
        MeshComp->AddImpulse(FVector(0.0f, RecoilForce.Y, 0.0f));
    }
}
void AMyCharacter::BeginPlay()
{
    Super::BeginPlay();
    if (GConfig)
    {
        float RecoilForceY = 0.0f;
        GConfig->GetFloat(TEXT("/Script/Engine.GameUserSettings"), TEXT("RecoilForceY"), RecoilForceY, GGameIni);
        RecoilForce.Y = RecoilForceY;
    }
}
void AMyCharacter::Autovoid AMyCharacter::AutoAim()
{
    APawn* ControlledPawn = GetController()->GetPawn();
    if (ControlledPawn == nullptr)
    {
        return;
    }
    APawn* TargetPawn = GetNearestPawn();
    if (TargetPawn == nullptr)
    {
        return;
    }
    FVector TargetLocation = TargetPawn->GetActorLocation();
    FVector DirectionToTarget = TargetLocation - ControlledPawn->GetActorLocation();
    DirectionToTarget.Normalize();
    FRotator TargetRotate = DirectionToTarget.Rotation();
    ControlledPawn->SetActorRotation(TargetRotate);
}
APawn* AMyCharacter::GetNearestPawn()
{
    TArray<AActor*> FoundActors;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), APawn::StaticClass(), FoundActors);

    APawn* NearestPawn = nullptr;
    float MinDistance = TNumericLimits<float>::Max();

    APawn* ControlledPawn = GetController()->GetPawn();
    FVector StartLocation = ControlledPawn->GetActorLocation();

    for (AActor* FoundActor : FoundActors)
    {
        APawn* Pawn = Cast<APawn>(FoundActor);

        if (Pawn && Pawn != ControlledPawn)
        {
            float Distance = FVector::DistSquared(StartLocation, Pawn->GetActorLocation());
            if (Distance < MinDistance)
            {
                MinDistance = Distance;
                NearestPawn = Pawn;
            }
        }
    }

    return NearestPawn;
}
void AYourPlayerController::ResetRotation()
{
FRotator CurrentRotation = GetControlRotation();
CurrentRotation.Yaw = 0.0f;
SetControlRotation(CurrentRotation);
}
UCLASS()
class YOURGAME_API AYourPlayerController : public APlayerController
{
    GENERATED_BODY()
public:
UFUNCTION(BlueprintCallable)
    void ResetRotation();
    void AYourPlayerController::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
    Super::SetupPlayerInputComponent(PlayerInputComponent);
    PlayerInputComponent->BindAction("Aim", IE_Pressed, this, &AYourPlayerController::ResetRotation);
    
    #include "GameFramework/Actor.h"
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();

if (PlayerController)
{
  PlayerController->SetFrameRate(0.0f);
  PlayerController->bSmoothFrameRate = true;
  PlayerController->MinDesiredFrameRate = 30;
  PlayerController->MaxDesiredFrameRate = 60;
  GEngine->SetMaxFPS(60);
  GEngine->bSmoothFrameRate = true;
}
void AYourCharacter::LookUpAtRate(float Rate)
{
    AddControllerPitchInput(Rate * BaseLookUpRate * GetWorld()->GetDeltaSeconds());
}
void AYourCharacter::TurnAtRate(float Rate)
{
    AddControllerYawInput(Rate * BaseTurnRate * GetWorld()->GetDeltaSeconds());
}
float AMyCharacter::CalculateMaxBodyDamage(float BaseDamage, float HeadDamageMultiplier, float BodyDamageMultiplier, float LimbDamageMultiplier)
{
    float BodyDamage = BaseDamage * BodyDamageMultiplier;
    return BodyDamage;
}
void AGun::Fire()
{
    APlayerController* PlayerController = UGameplayStatics::GetPlayerController(this, 0);
    if (PlayerController)
    {
        ACharacter* PlayerCharacter = PlayerController->GetCharacter();
        if (PlayerCharacter)
        {
            USkeletalMeshComponent* PlayerMesh = PlayerCharacter->GetMesh();
            if (PlayerMesh)
            {
                FName HeadBoneName = PlayerMesh->GetBoneName(playerConfig.HeadBoneIndex);
                if (PlayerMesh->GetBoneIndex(HeadBoneName) != INDEX_NONE)
                {
                    FTransform HeadTransform = PlayerMesh->GetBoneTransform(playerConfig.HeadBoneIndex);
                    FVector HeadPosition = HeadTransform.GetTranslation();
                    FVector HeadDirection = HeadTransform.GetRotation().GetForwardVector();
                    FVector HitPosition = HeadPosition + HeadDirection * gunConfig.Range;
                    InputComponent->BindAxis("aLookUpRate", this, &AYourCharacter::LookUpAtRate);
                    void AYourCharacter::LookUpAtRate(float Rate)
{
    AddControllerPitchInput(Rate * 90.f * GetWorld()->GetDeltaSeconds());
}
void AMyCharacter::Attack()
{
    float finalDamage = baseDamage * DamageMultiplier;
    ApplyDamageToEnemy(finalDamage);
}
AMyCharacter::AMyCharacter()
{
    DamageMultiplier = 100.0f;
}
AMyCharacter::AMyCharacter()
{
   FullDamage = 10000.0f;
   GunHitDamageMax=true
   bGunHitDamageMax=true
}
void AMyCharacter::SetFullDamage(float MaxDamage)
{
   FullDamage = MaxDamage;
}
float AMyCharacter::GetFullMaxDamage() const
{
   return FullMaxDamage;
}
void AMyCharacter::TakeDamage(float MaxDamageAmount)
{
   float TotalMaxDamage = MaxDamageAmount * FullMaxDamage;
   void AYourCharacter::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);

    if (GEngine->XRSystem.IsValid() && GEngine->XRSystem->IsHeadTrackingAllowed())
    {
        FQuat HeadRotation;
        GEngine->XRSystem->GetCurrentPose(IXRTrackingSystem::HMDDeviceId, HeadRotation);
        FRotator NewRotation = HeadRotation.Rotator();
        SetActorRotation(NewRotation);
    }
}
void AYourCharacter::BeginPlay()
{
    Super::BeginPlay();
    USkeletalMeshComponent* SkeletalMeshComponent = GetMeshComponent();
    UStaticMesh* DynamicMesh = LoadObject<UStaticMesh>(nullptr, TEXT("/Game/Path/To/YourDynamicMesh"));
    SkeletalMeshComponent->SetStaticMesh(DynamicMesh);
    UMaterialInterface* DynamicMaterial = LoadObject<UMaterialInterface>(nullptr, TEXT("/Game/Path/To/YourDynamicMaterial"));
    SkeletalMeshComponent->SetMaterial(0, DynamicMaterial);
}
#include "CoreMinimal.h"
#include "GameFramework/Character.```cpp
#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "MyCharacter.generated.h"

UCLASS()
class MYPROJECT_API AMyCharacter : public ACharacter
{
    GENERATED_BODY()

public:
    AMyCharacter();

protected:
    virtual void BeginPlay() override;

public:
    virtual void Tick(float DeltaTime) override;

    // Function to increase body size
    UFUNCTION(BlueprintCallable, Category = "Character")
    void IncreaseBodySize(float ScaleFactor);

private:
    // Variable to store the current body scale
    UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Character", meta = (AllowPrivateAccess = "true"))
    FVector CurrentBodyScale;

    // Maximum scale factor for the body
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Character", meta = (AllowPrivateAccess = "true"))
    float MaxBodyScaleFactor;
};
#include "MyCharacter.h"

AMyCharacter::AMyCharacter()
{
    // Set default values
    MaxBodyScaleFactor = 2.0f;
    CurrentBodyScale = GetActorScale3D();
}

void AMyCharacter::BeginPlay()
{
    Super::BeginPlay();
}

void AMyCharacter::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
}

void AMyCharacter::IncreaseBodySize(float ScaleFactor)
{
    // Calculate the new scale factor
    float NewScaleFactor = FMath::Clamp(ScaleFactor, 1.0f, MaxBodyScaleFactor);

    // Set the new body scale
    FVector NewBodyScale = CurrentBodyScale * NewScaleFactor;

    // Set the actor scale
    SetActorScale3D(NewBodyScale);
}
float AYourCharacterClass::CalculateDamageMultiplier(FName HitBoneName)
{
    float DamageMultiplier = 1.0;

    FString BoneName = HitBoneName.ToString();
    UYourCharacterSkeleton* CharacterSkeleton = GetMesh()->GetSkeleton();
    if (BoneName.Contains(TEXT("head")))
    {
        DamageMultiplier = GConfig->GetFloat(TEXT("HitLocationMultipliers"), TEXT("Head"), 1.0f, GYourIniPath);
    }
    else if (BoneName.Contains(TEXT("spine")) || BoneName.Contains(TEXT("chest")))
    {
        DamageMultiplier = GConfig->GetFloat(TEXT("HitLocationMultipliers"), TEXT("Torso"), 1.0f, GYourIniPath);
    }
    else if (BoneName.Contains(TEXT("upperarm")) || BoneName.Contains(TEXT("lowerarm")))
    {
        DamageMultiplier = GConfig->GetFloat(TEXT("HitLocationMultipliers"), TEXT("Arms"), 1.0f, GYourIniPath);
    }
    else if (BoneName.Contains(TEXT("thigh")) || BoneName.Contains(TEXT("calf")))
    {
        DamageMultiplier = GConfig->GetFloat(TEXT("HitLocationMultipliers"), TEXT("Legs"), 1.0f, GYourIniPath);
    }

    return DamageMultiplier;
}
void AMyCharacter::ServerHandleHit_Implementation(AActor* HitActor)
{
    if (HitActor->IsValidLowLevel())
    {
    UPROPERTY(EditAnywhere, Category = Gameplay)
float HeadshotMultiplier;
void AMyCharacter::TakeDamage(float Damage, struct FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
bool bIsHeadshot = false;
if (bIsHeadshot)
    {
        Damage *= HeadshotMultiplier;
        Super::TakeDamage(Damage, DamageEvent, EventInstigator, DamageCauser);
}
GetMesh()->BodyInstance.SetCollisionProfileName("HeadShot");
GetMesh()->BodyInstance.SetProfileParameter(TEXT("DepthPriorityGroup"), 5);
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if (PlayerController)
{
    PlayerController->ClientPredictedProjectileMaxSimulationTime = 0.5f;
}
void AYourPlayerController::BeginPlay()
{
    Super::BeginPlay();
    
    UPlayer* OwningPlayer = GetLocalPlayer();
    if (OwningPlayer)
    {
        FConfigFile* GameUserSettings = GConfig->Find(FString("/Script/Engine.Player"), true);
        if (GameUserSettings)
        {
            GameUserSettings->SetFloat(TEXT("ConfiguredAimLimitDegrees"), 90.0f);
        }
        else
        {
            UE_LOG(LogTemp, Warning, TEXT("Failed to find GameUserSettings"));
        }
    }
}
#include "GameFramework/PlayerController.h"
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if(PlayerController)
{
PlayerController->AimAssistMaxType = 1
void AMyCharacter::ToggleAim()
{
    bIsAiming = !bIsAiming;

    if (bIsAiming)
    {
    CameraComponent->SetFieldOfView(AimFOV);
    }
    else
    {
    CameraComponent->SetFieldOfView(DefaultFOV);
    }
}
void AMyCharacter::AutoAim()
{
FVector TargetLocation = FindNearestEnemyLocation();
    FRotator TargetRotation = UKismetMathLibrary::FindLookAtRotation(GetActorLocation(), TargetLocation);
    SetActorRotation(TargetRotation);
}
void AMyCharacter::TakeDamage(int32 DamageAmount, const FDamageEvent& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
    Super::TakeDamage(DamageAmount, DamageEvent, EventInstigator, DamageCauser);
    
    FHitResult HitResult;
    FVector StartTrace = GetActorLocation() + FVector(0.f, 0.f, 50.f);
    FVector EndTrace = StartTrace + GetActorForwardVector() * 1000.f;
    FCollisionQueryParams CollisionParams;
    CollisionParams.AddIgnoredActor(this);
    
    if (GetWorld()->LineTraceSingleByChannel(HitResult, StartTrace, EndTrace, ECC_Visibility, CollisionParams))
    {
        if (HitResult.BoneName.ToString() == "head")
        {
            HitResult.GetActor()->TakeDamage(DamageAmount, DamageEvent, EventInstigator, DamageCauser);
        }
    }
}
void AYourCharacter::TakeDamage(float Damage, FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
    Super::TakeDamage(Damage, DamageEvent, EventInstigator, DamageCauser);
    float MaxDamage = MAX_float;
    UCLASS()
class YOURGAME_API AYourCharacter : public ACharacter
{
    GENERATED_BODY()

public:
    UPROPERTY(EditAnywhere, Category = "Combat")
    float MaxDamage = 100.0f;
};
AMyCharacter::AMyCharacter()
{
UCapsuleComponent* CollisionCapsule = GetCapsuleComponent();
    CollisionCapsule->SetCollisionProfileName(TEXT("CustomLyingDown"));
    CollisionCapsule->SetCapsuleHalfHeight(50.0f);
    CollisionCapsule->SetCapsuleRadius(30.0f);
    
    void AYourCharacter::SetCrouchedHalfHeight(float NewCrouchedHalfHeight)
{
    GetCharacterMovement()->CrouchedHalfHeight = NewCrouchedHalfHeight;
}
float AYourCharacter::GetCrouchedHalfHeight() const
{
    return GetCharacterMovement()->CrouchedHalfHeight;
}
void AMyCharacter::BeginPlay()
{
    Super::BeginPlay();

    MaxHitRange = 1000.0f;
    #include "MyCharacter.h"

AMyCharacter::AMyCharacter()
{
    PrimaryActorTick.bCanEverTick = true;
    maxDamage = 100.0f;
}
void AMyCharacter::BeginPlay()
{
    Super::BeginPlay();
}
void AMyCharacter::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
}
void AMyCharacter::DealMaxDamageToEnemy()
{
}
void AMyCharacter::TakeDamageFromBullet(float DamageAmount)
{
    if (DamageAmount > MaxDamage)
    {
    void AYourCharacterClass::UpdateAnimation(float DeltaSeconds)
{
    Super::UpdateAnimation(DeltaSeconds);
    if (CharacterMovement && CharacterMovement->IsProne() && CharacterMovement->bUseControllerDesiredRotation)
    {
        CharacterMovement->bUseControllerDesiredRotation = false;
    }
}
void AMyCharacter::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
    Super::SetupPlayerInputComponent(PlayerInputComponent);

    PlayerInputComponent->BindAction("Fire", IE_Pressed, this, &AMyCharacter::Fire);
}
void AMyCharacter::Fire()
{
    FVector ForwardVector = GetActorForwardVector();
    ForwardVector = ApplyShotAccuracy(ForwardVector);
}
FVector AMyCharacter::ApplyShotAccuracy(FVector Direction) const
{
    FVector NewDirection = Direction;
    if (Accuracy < 1.0f)
    {
        FRotator RandomRotator = FRotator(FMath::FRandRange(-1.0f, 1.0f) * (1.0f - Accuracy) * 90.0f, 
                                          FMath::FRandRange(-1.0f, 1.0f) * (1.0f - Accuracy) * 90.0f,
                                          0.0f);
        NewDirection = RandomRotator.RotateVector(Direction);
    }
    return NewDirection;
}
#include "MyRecoilSettings.h"
void AMyCharacter::HandleScopedFire()
{
    UMyRecoilSettings* RecoilSettings = GetDefault<UMyRecoilSettings>();
    float RecoilMultiplier = RecoilSettings->ScopedRecoilMultiplier;
    float HorizontalRecoil = RecoilSettings->ScopedHorizontalRecoil;
    float VerticalRecoil = RecoilSettings->ScopedVerticalRecoil;
    FVector RecoilVector = FVector(HorizontalRecoil, VerticalRecoil, 0.0f) * RecoilMultiplier;
    AimDirection += RecoilVector;
}
void AYourCharacter::TakeDamage(float DamageAmount)
{
    if (DamageAmount > 0.f)
    {
        Health -= DamageAmount;

        if (Health <= 0.f)
        {
            Die();
        }
    }
}
void AYourCharacter::Die()
{
#include "MyCharacter.h"
AMyCharacter::AMyCharacter()
{
	PrimaryActorTick.bCanEverTick = true;
}
void AMyCharacter::BeginPlay()
{
	Super::BeginPlay();
}
void AMyCharacter::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}
float AMyCharacter::CalculateDamageWithArmorPenetration(float BaseDamage, float ArmorValue, float ArmorPenetration)
{
    float ActualDamage = BaseDamage;
    float DamageReduction = FMath::Clamp(ArmorValue * 0.01f, 0.0f, 0.8f);
    ActualDamage = (1 - DamageReduction) * ActualDamage * (1 + ArmorPenetration);
    return ActualDamage;
}