#include "MyProjectile.h"
#include "Components/StaticMeshComponent.h"
#include "GameFramework/ProjectileMovementComponent.h"
#include "Particles/ParticleSystemComponent.h"
#include "Kismet/GameplayStatics.h"
AMyProjectile::AMyProjectile()
{
    ProjectileMovement = CreateDefaultSubobject<UProjectileMovementComponent>(TEXT("ProjectileMovement"));
    ProjectileMovement->UpdatedComponent = MeshComponent;
    ProjectileMovement->InitialSpeed = 3000.f;
    ProjectileMovement->MaxSpeed = 3000.f;
    ProjectileMovement->bRotationFollowsVelocity = true;
    ProjectileMovement->bShouldBounce = false;
    MeshComponent = CreateDefaultSubobject<UStaticMeshComponent>(TEXT("MeshComponent"));
    MeshComponent->SetCollisionProfileName(TEXT("BlockAll"));
    ProjectileParticle = CreateDefaultSubobject<UParticleSystemComponent>(TEXT("ProjectileParticle"));
    ProjectileParticle->SetupAttachment(MeshComponent);
    ProjectileParticle->bAutoActivate = false;
    ProjectileParticle->SetCollisionEnabled(ECollisionEnabled::NoCollision);
    ProjectileDamage = 10.f;
}
void AMyProjectile::BeginPlay()
{
    Super::BeginPlay();
    MeshComponent->OnComponentHit.AddDynamic(this, &AMyProjectile::OnProjectileCollision);
}
void AMyProjectile::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
}
void AMyProjectile::ApplyDamage(AActor* OtherActor)
{
    if (OtherActor)
    {
        UGameplayStatics::ApplyDamage(OtherActor, ProjectileDamage, nullptr, this, nullptr);
    }
    Destroy();
}
void AMyProjectile::OnProjectileCollision(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit)
{
    if (OtherActor && OtherActor != this && OtherActor != GetOwner())
    {
        ApplyDamage(OtherActor);
    }
}
void MyProjectileClass::ApplyDamage(AActor* DamagedActor, float DamageAmount, const FHitResult& HitInfo, AController* EventInstigator, AActor* DamageCauser)
{
Super::ApplyDamage(DamagedActor, DamageAmount, HitInfo, EventInstigator, DamageCauser);
}
