UFUNCTION(Server, Reliable)
   void ServerShoot(FVector Location, FRotator Rotation);
   
   void AMyPlayerController::Shoot()
   {
       FVector ShootLocation;
       FRotator ShootRotation;
       GetControllerPointOfView(EPovIndex::FirstPerson, ShootLocation, ShootRotation);
   
       ServerShoot(ShootLocation, ShootRotation);
   }
void AMyPlayerController::ServerShoot_Implementation(FVector Location, FRotator Rotation)
   {
ShootMulticast(Location, Rotation);
   }
UFUNCTION(NetMulticast, Reliable)
   void ShootMulticast(FVector Location, FRotator Rotation);
   
   void AMyPlayerController::ShootMulticast_Implementation(FVector Location, FRotator Rotation)
   {
UWorld* World = GetWorld();
       if (World)
       {
FHitResult HitResult;
           FVector EndLocation = Location + Rotation.Vector() * MaxTraceDistance;
           FCollisionQueryParams QueryParams;
           QueryParams.AddIgnoredActor(GetPawn());
           if (World->LineTraceSingleByChannel(HitResult, Location, EndLocation, ECC_Visibility, QueryParams))
           {
FVector ImpactPoint = HitResult.ImpactPoint;
               FRotator ImpactRotation = HitResult.ImpactNormal.Rotation();
           }
           else
           {
FVector ImpactPoint = EndLocation;
               FRotator ImpactRotation = FRotator(0, FMath::RandRange(0, 360), 0);
           }
       }
   }
   
void AMyPlayerController::Tick(float DeltaTime)
   {
       Super::Tick(DeltaTime);
for (FConstPawnIterator It = GetWorld()->GetPawnIterator(); It; ++It)
       {
           APawn* Pawn = It->Get();
           if (Pawn && Pawn != GetPawn())
           {
FVector PredictedLocation;
               float Ping = GetNetworkPing();
               if (GetPovPawnLocationAndSpeed(Pawn, Ping + DeltaTime, PredictedLocation))
               {
FVector RotationAdjustedLocation = RotationAdjustment(Pawn->GetActorRotation(),
                       PredictedLocation, GetViewTarget()->GetActorLocation());
                   FVector SmoothedLocation = FMath::VInterpTo(Pawn->GetActorLocation(), RotationAdjustedLocation,
                       DeltaTime, InterpolationSpeed);
                   Pawn->SetActorLocation(SmoothedLocation);
               }
           }
       }
   }