void APlayerCharacter::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
    Super::SetupPlayerInputComponent(PlayerInputComponent);
    
    PlayerInputComponent->BindAxis("TurnRate", this, &APlayerCharacter::TurnAtRate);
    PlayerInputComponent->BindAxis("LookUpRate", this, &APlayerCharacter::LookUpAtRate);
    PlayerInputComponent->BindAxis("Turn", this, &APlayerCharacter::Turn);
    PlayerInputComponent->BindAxis("LookUp", this, &APlayerCharacter::LookUp);
PlayerInputComponent->BindAxis("Zoom", this, &APlayerCharacter::Zoom);
}

void APlayerCharacter::Zoom(float Value)
{
    if (Value != 0.0f)
    {
float NewFOV = Camera->FieldOfView + (Value * ZoomSpeed);
        Camera->SetFieldOfView(FMath::Clamp(NewFOV, MinZoomFOV, MaxZoomFOV));
    }
}        
void AMyPlayerController::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
   Super::SetupPlayerInputComponent(PlayerInputComponent);
   
   PlayerInputComponent->BindAction("Fire", IE_Pressed, this, &AMyPlayerController::OnMousePressed);
   PlayerInputComponent->BindAction("Fire", IE_Released, this, &AMyPlayerController::OnMouseReleased);
   PlayerInputComponent->BindAxis("LookUp", this, &AMyPlayerController::OnMouseMove);
}

void AMyPlayerController::OnMousePressed()
{
   if (!bIsAiming)
   {
       bIsAiming = true;
       GetMousePosition(StartingMousePosition.X, StartingMousePosition.Y);
   }
}

void AMyPlayerController::OnMouseReleased()
{
   bIsAiming = false;
}

void AMyPlayerController::OnMouseMove(float X, float Y)
{
   if (bIsAiming)
   {
       FVector2D CurrentMousePosition;
       GetMousePosition(CurrentMousePosition.X, CurrentMousePosition.Y);

       FVector2D MouseDelta = CurrentMousePosition - StartingMousePosition;
MouseDelta *= GyroSensitivity;
FVector TargetLocation = GetPawn()->GetActorLocation();
       TargetLocation.X += MouseDelta.X;
       TargetLocation.Y -= MouseDelta.Y;
       GetPawn()->SetActorLocation(TargetLocation);

       StartingMousePosition = CurrentMousePosition;
   }
}       

void AYourPlayerController::EnableGyroInput()
{
    FInputDeviceIdentifier GyroIdentifier(TEXT("Gyroscope"));
    IInputDeviceModule* InputDeviceModule = IInputDeviceModule::GetModule();
    if (InputDeviceModule != nullptr)
    {
        IInputDevice* InputDevice = InputDeviceModule->CreateInputDevice(GyroIdentifier);
        if (InputDevice != nullptr)
        {
            InputDevice->SetMessageHandler(MakeShareable(new FGyroInputMessageHandler()));
            InputDeviceModule->ActivateDevice(GyroIdentifier);
        }
    }
}

void AYourPlayerController::DisableGyroInput()
{
    FInputDeviceIdentifier GyroIdentifier(TEXT("Gyroscope"));
    IInputDeviceModule* InputDeviceModule = IInputDeviceModule::GetModule();
    if (InputDeviceModule != nullptr)
    {
        InputDeviceModule->DeactivateDevice(GyroIdentifier);
        InputDeviceModule->RemoveInputDevice(GyroIdentifier);
    }
}