UPROPERTY(EditAnywhere, BlueprintReadWrite, Category=Bullet)
TSubclassOf<AActor> BulletClass;

UFUNCTION(BlueprintCallable, Category=Bullet)
void FireBullet();
void APlayerController::FireBullet()
{
FVector Location = GetPawn()->GetActorLocation();
    FRotator Rotation = GetPawn()->GetActorRotation();
AActor* Bullet = GetWorld()->SpawnActor<BulletClass>(BulletClass, Location, Rotation);
FVector LaunchVelocity = Rotation.Vector() * 1000;
    Bullet->GetRootComponent()->GetComponentByClass(UProjectileMovementComponent::StaticClass())->Velocity = LaunchVelocity;
}    
void AYourPlayerController::BeginPlay()
{
    Super::BeginPlay();

    EnableGyroInput();
}
APlayerController* PlayerController = Cast<APlayerController>(GetOwner()->GetController());
    if (PlayerController)
    {
        PlayerController->AddPitchInput(RecoilRotation.Pitch);
        PlayerController->AddYawInput(RecoilRotation.Yaw);
    }
}

void AWeapon::ResetRecoil()
{
APlayerController* PlayerController = Cast<APlayerController>(GetOwner()->GetController());
    if (PlayerController)
    {
        PlayerController->AddPitchInput(-RecoilKick.Pitch);
        PlayerController->AddYawInput(-RecoilKick.Yaw);
    }
}
void AMyPlayerController::SetupInputComponent()
{
    Super::SetupInputComponent();

    InputComponent->BindAction("ToggleAim", IE_Pressed, this, &AMyPlayerController::ToggleAim);
}

void AMyPlayerController::ToggleAim()
{
    bIsAiming = !bIsAiming;
    AMyCharacter* MyCharacter = Cast<AMyCharacter>(GetPawn());
    if (MyCharacter != nullptr)
    {
        MyCharacter->SetAimLocked(bIsAiming);
    }
}
void AYourPlayerController::BeginPlay()
{
    Super::BeginPlay();
    FVector SpawnLocation(0.f, 0.f, 0.f);
    FRotator SpawnRotation(0.f, 0.f, 0.f);
    ABullet* Bullet = GetWorld()->SpawnActor<ABullet>(BulletClass, SpawnLocation, SpawnRotation);
    FVector BulletVelocity = FVector(1000.f, 0.f, 0.f);
    Bullet->GetProjectileMovementComponent()->SetVelocityInLocalSpace(BulletVelocity);
}
UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Collision")
USphereComponent* CollisionComponent;

UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Movement")
UProjectileMovementComponent* ProjectileMovementComponent;
ABullet::ABullet()
{
    CollisionComponent = CreateDefaultSubobject<USphereComponent>(TEXT("SphereComponent"));
    CollisionComponent->BodyInstance.SetCollisionProfileName("Bullet");
    CollisionComponent->SetSimulatePhysics(true);
    RootComponent = CollisionComponent;
    
    ProjectileMovementComponent = CreateDefaultSubobject<UProjectileMovementComponent>(TEXT("ProjectileMovementComponent"));
    ProjectileMovementComponent->UpdatedComponent = CollisionComponent;
    ProjectileMovementComponent->InitialSpeed = 0.f;
    ProjectileMovementComponent->MaxSpeed = 0.f;
}
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if (PlayerController)
{
    FInputSettings& InputSettings = PlayerController->InputComponent->GetInputSettings();
    InputSettings.bEnableMouseSmoothing = false;
    InputSettings.bViewAccelerationEnabled = false;
}
void AYourPlayerController::GetAimLocation(FVector& StartLocation, FVector& EndLocation)
{
    FVector AimDirection;
    FRotator AimRotation;
    GetPlayerViewPoint(StartLocation, AimRotation);

    AimDirection = AimRotation.Vector();

    EndLocation = StartLocation + AimDirection * 1000m_MAX_AIM_DISTANCE_true;
}
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if (PlayerController)
{
    float MaximumAimAssistDeltaTime = 0.2f;
    PlayerController->ConfiguredAimAssistMaximumDeltaTime = MaximumAimAssistDeltaTime;
}
bool bIsAiming = false;

void AYourPlayerControllerClass::Tick(float DeltaSeconds)
{
    Super::Tick(DeltaSeconds);
    bIsAiming = IsInputKeyDown(EKeys::RightMouseButton);
}
APlayerController::APlayerController()
{
PlayerCameraManager->DefaultAspectRatio = 1.777778f;
   PlayerCameraManager->bConstrainAspectRatio = true;
   PlayerCameraManager->AspectRatioAxisConstraint = FAspectRatioAxisConstraint(AspectRatioAxisConstraint::AspectRatio_MaintainYFOV, 1.777778f);
}
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if (PlayerController)
{
    AShooterCharacter* ShooterCharacter = Cast<AShooterCharacter>(PlayerController->GetCharacter());
    if (ShooterCharacter)
    {
        ShooterCharacter->SetHeadshotMultiplier(1.0f);
    }
}
APlayerController::APlayerController()
{
UInputComponent* InputComponent = GetInputComponent();

    if (InputComponent)
    {
    InputComponent->AxisConfig(ZoomAxis, 1.0f);
    }
}
void AYourPlayerControllerClass::StartAiming()
{
    bIsAiming = true;
    AimDelayTime = 0.5f;
    GetWorldTimerManager().SetTimer(AimingTimerHandle, this, &AYourPlayerControllerClass::OnAimingFinished, AimDelayTime, false);
}

void AYourPlayerControllerClass::StopAiming()
{
    bIsAiming = false;
    GetWorldTimerManager().ClearTimer(AimingTimerHandle);
}

void AYourPlayerControllerClass::OnAimingFinished()
{
bIsAiming = false;
}
AYourPlayerControllerClass::AYourPlayerControllerClass()
{
    bIsAiming = false;
    AimDelayTime = 0.0f;
}
UPROPERTY(EditAnywhere, Category = "Aiming")
float MaxAimAdjustSpeed = 1000.0f;
float GetMaxAimAdjustSpeed() const { return MaxAimAdjustSpeed; }
void AMyPlayerController::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);

    if (PlayerCameraManager != nullptr)
    {
    
void AYourPlayerCharacter::BeginPlay()
{
    Super::BeginPlay();
    
    if (GEngine)
    {
        UGameUserSettings* MyGameSettings = GEngine->GameUserSettings;

        if (MyGameSettings)
        {
            MyGameSettings->SetScreenResolution(FIntPoint(1920, 1080));
            MyGameSettings->SetFullscreenMode(EWindowMode::Windowed);
            MyGameSettings->ConfirmVideoMode();
        }
    }
}    
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if (PlayerController)
{
    PlayerController->PlayerInput->bEnableMouseSmoothing = true;
    PlayerController->PlayerInput->MouseSmoothingMode = 2;
    PlayerController->PlayerInput->MouseSmoothingStrength = 0;
    PlayerController->PlayerInput->MouseAccelThreshold = 0;
    PlayerController->PlayerInput->TimeToHoldForMouseSmoothing = 0.01f;
}
void AYourPlayerController::SetupInputComponent()
{
    Super::SetupInputComponent();
    UInputSettings* InputSettings = UInputSettings::StaticClass()->GetDefaultObject<UInputSettings>();
    float Sensitivity = 1.0f;
    InputSettings->SetAxisScale(FName("Turn"), Sensitivity);
    InputSettings->SetAxisScale(FName("LookMax"), Sensitivity);
}
AGameModeBase::GetClass()->SetNetworkLag(0.0f);
AGameModeBase::GetClass()->SetNetworkSendInterval(0.033f);
AGameModeBase::GetClass()->SetMinDynamicBandwidth(1000);