#include "SniperRifle.h"
#include "Kismet/GameplayStatics.h"
#include "Engine/World.h"

ASniperRifle::ASniperRifle()
{
    PrimaryActorTick.bCanEverTick = false;
}

void ASniperRifle::BeginPlay()
{
    Super::BeginPlay();
OnFire.AddDynamic(this, &ASniperRifle::Fire);
bIsScopedIn = false;
}

void ASniperRifle::Fire()
{
    if (bIsScopedIn)
    {
FVector StartLocation = PlayerCameraComponent->GetComponentLocation();
        FVector EndLocation = StartLocation + PlayerCameraComponent->GetForwardVector() * FireRange;
        FHitResult HitResult;
        FCollisionQueryParams QueryParams;
        QueryParams.AddIgnoredActor(this);
bool bHitSomething = GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_GameTraceChannel1, QueryParams);

        if (bHitSomething)
        {
UGameplayStatics::SpawnEmitterAtLocation(GetWorld(), ImpactParticle, HitResult.ImpactPoint, HitResult.ImpactNormal.Rotation());
AActor* HitActor = HitResult.GetActor();
            if (HitActor && HitActor->ActorHasTag("Enemy"))
            {
                AEnemy* Enemy = Cast<AEnemy>(HitActor);
                if (Enemy)
                {
                    Enemy->TakeDamage(DamageAmount);
                }
            }
        }
UpdateCrosshair();
    }
    else
    {
void ASniperRifle::ToggleScope()
{
    bIsScopedIn = !bIsScopedIn;

    if (bIsScopedIn)
    {           
PlayerCameraComponent->SetFieldOfView(ScopeFOV);
    }
    else
    {
PlayerCameraComponent->SetFieldOfView(DefaultFOV);
    }
UpdateCrosshair();
}
void ASniperRifle::UpdateCrosshair()
{
if (bIsScopedIn)
    {
        CrosshairWidget->SetBrushFromTexture(ScopedInCrosshairTexture);
    }
    else
    {
        CrosshairWidget->SetBrushFromTexture(ScopedOutCrosshairTexture);
    }
}
#include "SniperRiflePlayerController.h"
#include "SniperRifle.h"

void ASniperRiflePlayerController::BeginPlay()
{
    Super::BeginPlay();
InputComponent->BindAction("ToggleScope", IE_Pressed, this, &ASniperRiflePlayerController::ToggleScope);
}

void ASniperRiflePlayerController::ToggleScope()
{
    if (ASniperRifle* SniperRifle = Cast<ASniperRifle>(GetPawn()))
    {
        SniperRifle->ToggleScope();
    }
}                                         