void AYourPlayerController::ReduceAimDownSightsShake()
{
    if (PlayerCameraManager != nullptr)
    {
        PlayerCameraManager->ViewPitchMin = -20.0f;
        
PlayerCameraManager->ViewPitchMax = 20.0f;
PlayerCameraManager->ViewYawMin = -20.0f;
PlayerCameraManager->ViewYawMax = 20.0f;

AActor* AYourCharacter::AutoTargetingFunction()
{
    TArray<AActor*> FoundActors;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), AYourTargetClass::StaticClass(), FoundActors);

    AActor* BestTarget = nullptr;
    float BestDistance = AutoTargetingRange;

    for (AActor* Target : FoundActors)
    {
        float Distance = FVector::Dist(Target->GetActorLocation(), GetActorLocation());
        if (Distance < BestDistance)
        {
            BestTarget = Target;
            BestDistance = Distance;
        }
    }

    return BestTarget;
}

class ACharacter : public AActor
{
    GENERATED_BODY()

public:
    // Apply damage to the character
    UFUNCTION(BlueprintCallable)
    void TakeDamage(float Damage);

private:
    float Health;
};

// Character.cpp
void ACharacter::TakeDamage(float Damage)
{
    // Apply damage to the character
    Health -= Damage;

    if (Health <= 0)
    {
        // Character dies
        Die();
    }
}

void ACharacter::Die()
{
    // Character death logic
}

void ABullet::OnHitPlayer()
{
float BulletDamage = 0.0f;
    if (GConfig)
    {
        GConfig->GetFloat(TEXT("/Script/PUBG.MySettings"), TEXT("BulletDamage"), BulletDamage, GGameIni);
    }

    APlayerCharacter* HitPlayer = Cast<APlayerCharacter>(HitComponent->GetOwner());
    if (HitPlayer)
    {
        float CurrentPlayerHealth = 0.0f;
        if (GConfig)
        {
            GConfig->GetFloat(TEXT("/Script/PUBG.MySettings"), TEXT("PlayerHealth"), CurrentPlayerHealth, GGameIni);
        }
        CurrentPlayerHealth -= BulletDamage;

        GConfig->SetFloat(TEXT("/Script/PUBG.MySettings"), TEXT("PlayerHealth"), CurrentPlayerHealth, GGameIni);
if (CurrentPlayerHealth <= 0.0f)
        {
HitPlayer->Die();
        }
        else
        {
            int32 HitCount = 0;
            GConfig->GetInt(TEXT("/Script/PUBG.PUBGState"), TEXT("HitCount"), HitCount, GGameIni);
HitCount++;

            if (HitCount >= 2)
            {
HitPlayer->Die();
            }
            else
            {
                GConfig->SetInt(TEXT("/Script/PUBG.PUBGState"), TEXT("HitCount"), HitCount, GGameIni);
            }
        }
    }
}

void APlayerCharacter::Die()
{

void AYourCharacterClass::ControlAccuracy()
{
FVector CurrentDirection = GetActorForwardVector();
FVector AccuracyModifier = CurrentDirection * AccuracyModifierValue;
FVector NewDirection = CurrentDirection + AccuracyModifier;
SetActorRotation(NewDirection.Rotation());
}

UPROPERTY(EditAnywhere, Category = "Aiming")
float MaxRecoilReduction = 0.5f;
void AYourWeaponClass::ReduceRecoilOnAim()
{
bool bIsAiming = GetPlayerAiming();
if (bIsAiming)
    {
CurrentRecoilMagnitude -= MaxRecoilReduction;
if (CurrentRecoilMagnitude < 0)
        {
            CurrentRecoilMagnitude = 0;
        }
    }
}

Event FireButtonPressed()
{
Spawn Bullet;
Bullet.SetVelocityAndDirection(...
PlayShootAnimation();
PlayFireSound();
}
Event AimButtonPressed()
{
DecreaseWeaponAccuracy();
}

class Player
{
private:
    int health;

public:
    void UseMedicalItem(int healingAmount);
};

// 玩家使用医疗包的函数实现
void Player::UseMedicalItem(int healingAmount)
{
    // 播放使用医疗包的动画或特效

    // 触发快速治愈
    StartQuickHealing(healingAmount);
}

// 触发快速治愈的函数实现
void Player::StartQuickHealing(int amount)
{
    // 增加玩家的生命值
    health += amount;

    // 更新UI显示
    UpdateHealthBar(health);

    // 播放治愈动画或特效
}

// 更新UI的函数实现
void UpdateHealthBar(int health)
{

UPROPERTY(EditAnywhere, Category = "Character")
float AutoShootDelay;
FTimerHandle AutoShootTimerHandle;

void AYourCharacter::StartAutoShoot()
{
    GetWorldTimerManager().SetTimer(AutoShootTimerHandle, this, &AYourCharacter::AutoShoot, AutoShootDelay, true);
}

void AYourCharacter::StopAutoShoot()
{
    GetWorldTimerManager().ClearTimer(AutoShootTimerHandle);
}

void AYourCharacter::AutoShoot()
{
Fire();
}

UPROPERTY(EditAnywhere, Category = "Character")
bool bIgnoreKnockback;
void AYourCharacter::TakeHit()
{
    if (!bIgnoreKnockback)
    {
Health -= Damage;
        ApplyKnockback();
    }
    else
    {
    
UCLASS()
class YOURGAME_API AYourCharacter : public ACharacter
{
    GENERATED_BODY()

public:
    // Declare the range for auto targeting
    UPROPERTY(EditAnywhere, Category=AutoTargeting)
    float AutoTargetingRange;

    // Declare the function for auto targeting
    UFUNCTION(BlueprintCallable, Category=AutoTargeting)
    AActor* AutoTargetingFunction();
};

AActor* AYourCharacter::AutoTargetingFunction()
{
    TArray<AActor*> FoundActors;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), AYourTargetClass::StaticClass(), FoundActors);

    AActor* BestTarget = nullptr;
    float BestDistance = AutoTargetingRange;

    for (AActor* Target : FoundActors)
    {
        float Distance = FVector::Dist(Target->GetActorLocation(), GetActorLocation());
        if (Distance < BestDistance)
        {
            BestTarget = Target;
            BestDistance = Distance;
        }
    }

    return BestTarget;
}

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Bullet.generated.h"

UCLASS()
class YOURGAME_API ABullet : public AActor
{
    GENERATED_BODY()

public:
    // Sets default values for this actor's properties
    ABullet();

protected:
    // Called when the game starts or when spawned
    virtual void BeginPlay() override;

public:
    // Called every frame
    virtual void Tick(float DeltaTime) override;

    // Function to handle bullet movement
    UFUNCTION()
    void MoveBullet(float DeltaTime);

    // Function to handle bullet collision
    UFUNCTION()
    void HandleCollision();
};

#include "Bullet.h"
#include "GameFramework/ProjectileMovementComponent.h"

// Sets default values
ABullet::ABullet()
{
    // Set this actor to call Tick() every frame
    PrimaryActorTick.bCanEverTick = true;

    // Create a projectile movement component
    ProjectileMovement = CreateDefaultSubobject<UProjectileMovementComponent>(TEXT("ProjectileMovement"));
    if (ProjectileMovement)
    {
        ProjectileMovement->UpdatedComponent = RootComponent;
        ProjectileMovement->InitialSpeed = 3000.f; // 设置初始速度
        ProjectileMovement->MaxSpeed = 3000.f;

    }
}

// Called when the game starts or when spawned
void ABullet::BeginPlay()
{
    Super::BeginPlay();
}

// Called every frame
void ABullet::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);

    MoveBullet(DeltaTime);
}

// Function to handle bullet movement
void ABullet::MoveBullet(float DeltaTime)
{
    if (ProjectileMovement)
    {
        ProjectileMovement->Velocity = GetActorForwardVector() * ProjectileMovement->InitialSpeed;
    }
}

// Function to handle bullet collision
void ABullet::HandleCollision()
{

UFUNCTION(Server, Reliable)
   void ServerShoot(FVector Location, FRotator Rotation);
   
   void AMyPlayerController::Shoot()
   {
       FVector ShootLocation;
       FRotator ShootRotation;
       GetControllerPointOfView(EPovIndex::FirstPerson, ShootLocation, ShootRotation);
   
       ServerShoot(ShootLocation, ShootRotation);
   }
void AMyPlayerController::ServerShoot_Implementation(FVector Location, FRotator Rotation)
   {
ShootMulticast(Location, Rotation);
   }
UFUNCTION(NetMulticast, Reliable)
   void ShootMulticast(FVector Location, FRotator Rotation);
   
   void AMyPlayerController::ShootMulticast_Implementation(FVector Location, FRotator Rotation)
   {
UWorld* World = GetWorld();
       if (World)
       {
FHitResult HitResult;
           FVector EndLocation = Location + Rotation.Vector() * MaxTraceDistance;
           FCollisionQueryParams QueryParams;
           QueryParams.AddIgnoredActor(GetPawn());
           if (World->LineTraceSingleByChannel(HitResult, Location, EndLocation, ECC_Visibility, QueryParams))
           {
FVector ImpactPoint = HitResult.ImpactPoint;
               FRotator ImpactRotation = HitResult.ImpactNormal.Rotation();
           }
           else
           {
FVector ImpactPoint = EndLocation;
               FRotator ImpactRotation = FRotator(0, FMath::RandRange(0, 360), 0);
           }
       }
   }
   
void AMyPlayerController::Tick(float DeltaTime)
   {
       Super::Tick(DeltaTime);
for (FConstPawnIterator It = GetWorld()->GetPawnIterator(); It; ++It)
       {
           APawn* Pawn = It->Get();
           if (Pawn && Pawn != GetPawn())
           {
FVector PredictedLocation;
               float Ping = GetNetworkPing();
               if (GetPovPawnLocationAndSpeed(Pawn, Ping + DeltaTime, PredictedLocation))
               {
FVector RotationAdjustedLocation = RotationAdjustment(Pawn->GetActorRotation(),
                       PredictedLocation, GetViewTarget()->GetActorLocation());
                   FVector SmoothedLocation = FMath::VInterpTo(Pawn->GetActorLocation(), RotationAdjustedLocation,
                       DeltaTime, InterpolationSpeed);
                   Pawn->SetActorLocation(SmoothedLocation);
               }
           }
       }
   }
   
UPROPERTY(EditAnywhere, Category = "Shake")
float ShakeIntensity;

UPROPERTY(EditAnywhere, Category = "Shake")
float ShakeFrequency;

UPROPERTY(EditAnywhere, Category = "Shake")
float ShakeDuration;
void AYourActor::StartShake()
{
    TArray<FShakeAnimation> ShakeAnimations;

    FVector OriginalLocation = GetActorLocation();
for (int32 i = 0; i < ShakeDuration; i++)
    {
        FShakeAnimation ShakeAnimation;
        ShakeAnimation.LocationDelta = FVector(
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity)
        );
        ShakeAnimation.RotationDelta = FRotator(
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity),
            FMath::FRandRange(-ShakeIntensity, ShakeIntensity)
        );
        ShakeAnimations.Add(ShakeAnimation);
    }
float ShakeTime = 0;
    while (ShakeTime < ShakeFrequency)
    {
        int32 ShakeIndex = FMath::RoundToInt(ShakeTime);
        if (ShakeIndex >= ShakeAnimations.Num())
        {
            break;
        }

        FVector LocationDelta = ShakeAnimations[ShakeIndex].LocationDelta;
        FRotator RotationDelta = ShakeAnimations[ShakeIndex].RotationDelta;

        SetActorLocation(OriginalLocation + LocationDelta);
        SetActorRotation(GetActorRotation() + RotationDelta);

        ShakeTime += GetWorld()->DeltaTimeSeconds;
        UGameplayStatics::GetPlayerController(GetWorld(), 0)->PlayerCameraManager->UpdateCameraShake(CameraShake, GetWorld()->DeltaTimeSeconds);
    }
SetActorLocation(OriginalLocation);
    SetActorRotation(OriginalRotation);
}

float LastInputTime;
void AYourActor::InputEvent()
{
    if (GetWorld()->GetTimeSeconds() - LastInputTime > 0.5f)
LastInputTime = GetWorld()->GetTimeSeconds();
    }
}

UPROPERTY(EditAnywhere, Category = "Aim Assist")
float AimAssistRange;

UPROPERTY(EditAnywhere, Category = "Aim Assist")
float AimAssistStrength;

UPROPERTY(EditAnywhere, Category = "Aim Assist")
TSubclassOf<AActor> AimAssistTargetClass;
AActor* AYourActor::GetAimAssistTarget()
{
    TArray<AActor*> Actors;
    UGameplayStatics::GetAllActorsOfClass(GetWorld(), AimAssistTargetClass, Actors);
float MinDistance = AimAssistRange;
    AActor* Target = nullptr;

    for (AActor* Actor : Actors)
    {
        float Distance = FVector::Distance(GetActorLocation(), Actor->GetActorLocation());
if (Distance < MinDistance)
        {
            MinDistance = Distance;
            Target = Actor;
        }
    }

    return Target;
}

void AYourActor::Tick(float DeltaSeconds)
{
    AActor* Target = GetAimAssistTarget();

    if (Target != nullptr)
    {
        FVector TargetDirection = Target->GetActorLocation() - GetActorLocation();
        TargetDirection.Normalize();

        FVector CameraForward = CameraComponent->GetForwardVector();
        CameraForward.Normalize();
FRotator LookRotation = TargetDirection.Rotation() - CameraForward.Rotation();
        LookRotation.Pitch = FMath::Clamp(LookRotation.Pitch, -AimAssistStrength, AimAssistStrength);
        LookRotation.Yaw = FMath::Clamp(LookRotation.Yaw, -AimAssistStrength, AimAssistStrength);
        SetActorRotation(GetActorRotation() + LookRotation);
    }
}

bool AYourActor::IsSaveFileValid()
{
    FString SaveFilePath = FPaths::ProjectSavedDir() + TEXT("SaveFile.sav");
    return FPlatformFileManager::Get().GetPlatformFile().FileExists(*SaveFilePath);
}

void AYourActor::BeginPlay()
{
    Super::BeginPlay();

    if (!IsSaveFileValid())
    {

void AYourActor::SetNetworkParameters()
{
    GetWorldSettings()->MaxTickRate = 60.0f;
GetWorldSettings()->bHighPriorityLoadingForLoadMap = true;
void AYourPlayerController::SetNetworkParameters()
{
    SetInputMode(FInputModeGameAndUI());
bShowMouseCursor = false;
SetReplicates(false);
    bAlwaysRelevant = true;
    bOnlyRelevantToOwner = true;
bNetUseOwnerRelevancy = true;
}

void AYourActor::SetOptimizationSettings()
{
    SetActorEnableCollision(false);
SetRenderCustomDepth(true);
SetReplicates(false);
SetHiddenInGame(true);
SetCanBeDamaged(false);

void AYourActor::SetOptimizationSettings()
{
SetRenderCustomDepth(true);
    CustomDepthStencilValue = 1;
SetReplicates(false);
    bAlwaysRelevant = true;
    bOnlyRelevantToOwner = true;
    bNetUseOwnerRelevancy = true;
}

void AYourActor::SetFrameRateLimit()
{
    SetActorTickEnabled(true);
    PrimaryActorTick.bCanEverTick = true;
    PrimaryActorTick.TickInterval = 1/90.0f;
}

void AYourCharacter::CheckWallAimLock()
{
    FVector StartLocation = GetCameraLocation();
FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
    FCollisionQueryParams CollisionParams;
    CollisionParams.bTraceComplex = true;
    CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_WorldStatic, CollisionParams);

    if (HitResult.bBlockingHit)
    {
if (HitResult.Actor->IsA(ABaseWall::StaticClass()))
        {
            bWallAimLock = true;
        }
        else
        {
            bWallAimLock = false;
        }
    }
    else
    {
        bWallAimLock = false;
    }
}

USkeletalMeshComponent* MeshComp = GetMesh();
if (MeshComp)
{
    MeshComp->SetAnimInstanceClass(YourAnimInstanceClass);
    MeshComp->SetAnimInstancePoseSnapshot(YourPoseSnapshot, true);
    MeshComp->SetAnimationMode(EAnimationMode::AnimationBlueprint);

Blend Speed
    UAnimInstance* AnimInstance = MeshComp->GetAnimInstance();
    if (AnimInstance)
    {
        AnimInstance->GetAnimBlueprintGeneratedClass()->SetMetaDataOfClass(TEXT("BlendSpace"), TEXT("BlendSpeed"), TEXT("YourSpeedValue"));
    }
}

void AYourCharacter::CheckAutoHeadshot()
{
FVector StartLocation = GetCameraLocation();
    FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
    FCollisionQueryParams CollisionParams;
    CollisionParams.bTraceComplex = true;
    CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, CollisionParams);

    if (HitResult.bBlockingHit)
    {
ABaseEnemy* Enemy = Cast<ABaseEnemy>(HitResult.Actor);
        if (Enemy && Enemy->GetMesh()->FindClosestBone(HitResult.BoneName) == HeadBoneName)
        {
float Damage = MaxHealth * HeadshotMultiplier;
            FPointDamageEvent DamageEvent(Damage, HitResult, GetAimDirection(), UDamageType::StaticClass());
            Enemy->TakeDamage(Damage, DamageEvent, nullptr, this);
        }
    }
}

void AYourCharacter::CheckAutoHeadIcon()
{
FVector StartLocation = GetCameraLocation();
    FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
    FCollisionQueryParams CollisionParams;
    CollisionParams.bTraceComplex = true;
    CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, CollisionParams);

    if (HitResult.bBlockingHit)
    {
ABaseEnemy* Enemy = Cast<ABaseEnemy>(HitResult.Actor);
        if (Enemy && Enemy->GetMesh()->FindClosestBone(HitResult.BoneName) == HeadBoneName)
        {
        
void AYourCharacter::CheckAimHeadshot()
{
    if (IsAiming())
    {
FVector StartLocation = GetCameraLocation();
        FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
        FCollisionQueryParams CollisionParams;
        CollisionParams.bTraceComplex = true;
        CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, CollisionParams);

        if (HitResult.bBlockingHit)
        {
ABaseEnemy* Enemy = Cast<ABaseEnemy>(HitResult.Actor);
            if (Enemy && Enemy->GetMesh()->FindClosestBone(HitResult.BoneName) == HeadBoneName)
            {
YourWidgetInstance->SetHeadshotCrosshair(true);
if (AimTime >= HeadshotAimTime)
                {
float Damage = MaxHealth * HeadshotMultiplier;
                    FPointDamageEvent DamageEvent(Damage, HitResult, GetAimDirection(), UDamageType::StaticClass());
                    Enemy->TakeDamage(Damage, DamageEvent, nullptr, this);
YourWidgetInstance->ShowHeadshotEffect(HitResult.Location);
AimTime = 0.0f;
                }
                else
                {
AimTime += GetWorld()->GetDeltaSeconds();
                }
            }
            else
            {
YourWidgetInstance->SetHeadshotCrosshair(false);
                AimTime = 0.0f;
            }
        }
        else
        {
YourWidgetInstance->SetHeadshotCrosshair(false);
            AimTime = 0.0f;
        }
    }
}        
                    
protected:
    UPROPERTY(EditDefaultsOnly, Category = "Damage")
    float MaxHealth = 100.0f;
UPROPERTY(BlueprintReadOnly, Category = "Damage")
    float Health = MaxHealth;

float AYourCharacter::TakeDamage(float DamageAmount, FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
    const float ActualDamage = Super::TakeDamage(DamageAmount, DamageEvent, EventInstigator, DamageCauser);

    if (ActualDamage > 0.0f)
    {
Health -= ActualDamage;
        if (Health <= 0.0f)
        {
Die();
        }
    }

    return ActualDamage;
}

void AYourCharacter::Die()
{

FPointDamageEvent DamageEvent(Damage, HitResult, GetAimDirection(), UDamageType::StaticClass());
HitedCharacter->TakeDamage(Damage, DamageEvent, InstigatorController, this);

Event BeginPlay()
{
SetCharacterMovementPrediction(true);
}

Event Tick(deltaTime)
{
Vector TargetLocation = GetPlayerTargetLocation();
if (bPredictiveMovement)
    {
        Vector PredictedLocation = PredictMovementLocation(TargetLocation);
InterpolateCharacterLocation(PredictedLocation, deltaTime);
    }
    else 
    {
        MoveCharacterTo(TargetLocation);
    }
}
                                          
UPROPERTY(EditAnywhere, Category = "Weapon")
float ProjectileSpeed;
FVector ShootDirection = GetActorForwardVector();
FVector ShootLocation = GetActorLocation();
FVector TargetLocation = Target->GetActorLocation();
FVector TargetVelocity = Target->GetVelocity();
FVector TargetLocation = Target->GetActorLocation();
FVector TargetVelocity = Target->GetVelocity();
float PredictedHitTime = FVector::Dist(TargetLocation, ShootLocation) / ProjectileSpeed;
FVector PredictedHitLocation = TargetLocation + (TargetVelocity * PredictedHitTime);

UPROPERTY(EditAnywhere, Category = "Weapon")
float AimAssistXSpeed;
UPROPERTY(EditAnywhere, Category = "Weapon")
float AimAssistYSpeed;
FVector TargetLocation = Target->GetActorLocation();
FVector ShootLocation = GetMuzzleLocation();
float DistanceToTarget = FVector::Dist(TargetLocation, ShootLocation);
float TimeToTarget = DistanceToTarget / ProjectileSpeed;
FVector AimAssistMovement = FVector(0.0f, AimAssistXSpeed * TimeToTarget, AimAssistYSpeed * TimeToTarget);
TargetLocation += AimAssistMovement;

UPROPERTY(EditAnywhere, Category = "Weapon")
float ProjectileSpeed;
UPROPERTY(EditAnywhere, Category = "Weapon")
float AimAssistTimeThreshold;
FVector TargetLocation = Target->GetActorLocation();
FVector TargetVelocity = Target->GetVelocity();
FVector ShootLocation = GetMuzzleLocation();
float DistanceToTarget = FVector::Dist(TargetLocation, ShootLocation);
float PredictedHitTime = DistanceToTarget / ProjectileSpeed;
if (PredictedHitTime > AimAssistTimeThreshold)
{
TargetLocation = Target->GetActorLocation();
}
else
{
TargetLocation += (TargetVelocity * PredictedHitTime);
}

UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Components")
UStaticMeshComponent* MeshComp;

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxShootDistance;
void AYourWeapon::Fire()
{
AController* OwnerController = GetOwnerController();
    APawn* OwnerPawn = GetOwnerPawn();
FCollisionQueryParams QueryParams;
    QueryParams.AddIgnoredActor(OwnerController);
    QueryParams.AddIgnoredActor(OwnerPawn);
    QueryParams.bTraceComplex = true;
    QueryParams.bReturnPhysicalMaterial = true;
FVector Start = GetMuzzleLocation();
    FVector End = Start + (FollowCamera->GetForwardVector() * MaxShootDistance);
Actor
    FHitResult Hit;
    if (GetWorld()->LineTraceSingleByChannel(Hit, Start, End, ECC_GameTraceChannel1, QueryParams))
    {
        AActor* HitActor = Hit.GetActor();
AYourVehicle* HitVehicle = Cast<AYourVehicle>(HitActor);
        if (HitVehicle != nullptr && HitVehicle->IsMoving())
        {
FVector ShootLocation = HitVehicle->GetClosestPointOnBounds(Start);
            HitVehicle->TakeDamage(Damage, FDamageEvent(), OwnerController, this);
            SpawnImpactEffects(Hit, Hit.PhysMaterial);
        }
        else
        {
            SpawnImpactEffects(Hit, Hit.PhysMaterial);
        }
    }
}

void AYourWeaponClass::HandleAutomaticFire()
{
    if (bIsFiring)
    {
Fire();
ApplyRecoil();
    }
}
void AYourWeaponClass::ApplyRecoil()
{

void AYourWeaponClass::ControlStability()
{
FRotator CurrentRotation = GetActorRotation();
FRotator StabilityModifier = FRotator(StabilityModifierPitch, StabilityModifierYaw, 0.0f);
FRotator NewRotation = CurrentRotation + StabilityModifier;
SetActorRotation(NewRotation);
}

void AYourCharacterClass::ControlAccuracy()
{
FVector CurrentDirection = GetActorForwardVector();
FVector AccuracyModifier = CurrentDirection * AccuracyModifierValue;
FVector NewDirection = CurrentDirection + AccuracyModifier;
SetActorRotation(NewDirection.Rotation());
}

UPROPERTY(EditAnywhere, Category = "Aiming")
float MaxRecoilReduction = 0.5f;
void AYourWeaponClass::ReduceRecoilOnAim()
{
bool bIsAiming = GetPlayerAiming();
if (bIsAiming)
    {
CurrentRecoilMagnitude -= MaxRecoilReduction;
if (CurrentRecoilMagnitude < 0)
        {
            CurrentRecoilMagnitude = 0;
        }
    }
}

void AWeapon::ReduceRecoil()
{
    if(bIsShooting)
    {
float DistanceToTarget = CalculateDistanceToTarget(); //
float RecoilReduction = FMath::Clamp(DistanceToTarget / MaxShootingDistance, 0.0f, 1.0f);
CurrentRecoil = FMath::Lerp(CurrentRecoil, MinRecoil, RecoilReduction);

void AWeapon::ReduceRecoilWithScope()
{
    if(bIsUsingScope && bIsShooting)
    {
float DistanceToTarget = CalculateDistanceToTarget();
float MaxRecoilReduction = 0.5f;
CurrentRecoil = FMath::Lerp(CurrentRecoil, MinRecoil, MaxRecoilReduction);

Get the interpolated recoil based on the time since last shot
    const float CurrentTime = GetWorld()->GetTimeSeconds();
    const float RecoilInterp = RecoilCurve->GetFloatValue(CurrentTime - LastFireTime);
    LastFireTime = CurrentTime;
Modify the weapon's rotation by the interpolated recoil amount
    const FRotator Recoil = FRotator(FMath::RandRange(-RecoilInterp, RecoilInterp), 0.f, 0.f);
    SetActorRotation(GetActorRotation() + Recoil);
Scale the impulse based on distance to target
    const float DistanceToTarget = FVector::Dist(StartTrace, TargetTraceEnd);
    const float ImpulseScale = FMath::GetMappedRangeValueClamped(FVector2D(MinDistance, MaxDistance), FVector2D(1.f, 0.1f), DistanceToTarget);
    const FVector Impulse = -MuzzleDirection * (ImpulseScale * ImpulseMultiplier);
Apply the impulse to the weapon
    MeshComp->AddImpulseAtLocation(Impulse, MuzzleLocation);

UPROPERTY(EditAnywhere, Category=weapon)
float MaxShakeMagnitude;
UPROPERTY(EditAnywhere, Category=weapon)
float MaxShakeFrequency;
FRandomStream ShakeRandomStream;
void Aweapon::Fire()
{
float ShakeMagnitude = FMath::RandRange(0.0f, MaxShakeMagnitude);
    float ShakeFrequency = FMath::RandRange(0.0f, MaxShakeFrequency);
    
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxShakeAmount;
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxShakeFrequency;
float CurrentShakeAmount;
float CurrentShakeTime;

void AWeapon::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
if (bIsShaking)
    {
        CurrentShakeTime += DeltaTime;
float ShakeValue = FMath::Sin(CurrentShakeTime * MaxShakeFrequency) * MaxShakeAmount;
SetActorRotation(GetActorRotation() + FRotator(0.0f, ShakeValue, 0.0f));
    }
}
void AWeapon::StartShake()
{
    bIsShaking = true;
    CurrentShakeAmount = MaxShakeAmount;
    CurrentShakeTime = 0.0f;
}
void AWeapon::StopShake()
{
    bIsShaking = false;

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxRecoilReduction;
void AMyWeapon::ReduceRecoil(float ReductionAmount)
{
float NewRecoil = FMath::Max(0.0f, Recoil - ReductionAmount);
SetRecoil(NewRecoil);
}

void AMyWeapon::SetRecoil(float NewRecoil)
{
Recoil = NewRecoil;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxDamage;
void AMyWeapon::HitTarget(AActor* TargetActor)
{
if (TargetActor != nullptr)
    {
float Damage = CalculateDamage(MaxDamage);
TargetActor->TakeDamage(Damage, FDamageEvent(), nullptr, this);
    }
}

float AMyWeapon::CalculateDamage(float BaseDamage)
{
return BaseDamage;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxBodyDamage;
void AMyWeapon::HitBody(AActor* TargetActor)
{
if (TargetActor != nullptr)
    {
ACharacter* TargetCharacter = Cast<ACharacter>(TargetActor);
        if (TargetCharacter != nullptr)
        {
float Damage = CalculateDamage(MaxBodyDamage);
FVector HitDirection = (TargetActor->GetActorLocation() - GetActorLocation()).GetSafeNormal();
            FPointDamageEvent DamageEvent(Damage, HitDirection, UDamageType::StaticClass(), nullptr);
            TargetActor->TakeDamage(Damage, DamageEvent, GetInstigatorController(), this);
        }
    }
}

float AMyWeapon::CalculateDamage(float BaseDamage)
{
return BaseDamage;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float HeadshotMultiplier;
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxHeadshotProbability;
float AMyWeapon::CalculateDamage(const FHitResult& Hit)
{
    float Damage = 0.f;
FString BoneName = Hit.BoneName.ToString();
if (BoneName.Contains(TEXT("head")))
    {
float RandomProbability = FMath::FRandRange(0.f, 1.f);
        float HeadshotProbability = MaxHeadshotProbability * (HitCount / 2);
if (RandomProbability <= HeadshotProbability)
        {
            Damage = CalculateHeadshotDamage(BaseDamage);
        }
    }
if (Damage == 0.f)
    {
        Damage = CalculateBaseDamage(BaseDamage);
    }

    return Damage;
}

float AMyWeapon::CalculateHeadshotDamage(float BaseDamage)
{
return BaseDamage * HeadshotMultiplier;
}

float AMyWeapon::CalculateBaseDamage(float BaseDamage)
{
return BaseDamage;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
int32 MaxBulletsPerShot;
UPROPERTY(EditAnywhere, Category = "Weapon")
float FireRate;
UPROPERTY(EditAnywhere, Category = "Weapon")
float TimeBetweenBullets;
void AMyWeapon::StartFire()
{
    if (!CanFire()) return;
float CurrentTime = GetWorld()->GetTimeSeconds();
if (CurrentTime > LastFireTime + 1.0f / FireRate)
    {
        FireBullet();
        LastFireTime = CurrentTime;
        BulletsThisShot = 1;
    }
    else if (BulletsThisShot < MaxBulletsPerShot)
    {
LastFireTime += TimeBetweenBullets;
        ++BulletsThisShot;
FireBullet();
if (BulletsThisShot < MaxBulletsPerShot && CanFire())
        {
            GetWorldTimerManager().SetTimer(FireTimer, this, &AMyWeapon::StartFire, TimeBetweenBullets, false);
        }
    }
}
void AMyWeapon::StopFire()
{
    GetWorldTimerManager().ClearTimer(FireTimer);
}
bool AMyWeapon::CanFire()
{
return true;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float HeadshotMultiplier;
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxHeadshotProbability;
float AMyWeapon::CalculateDamage(const FHitResult& Hit)
{
    float Damage = 0.f;
FString BoneName = Hit.BoneName.ToString();
if (BoneName.Contains(TEXT("head")))
    {
float RandomProbability = FMath::FRandRange(0.f, 1.f);
        float HeadshotProbability = MaxHeadshotProbability * (HitCount / 2);
if (RandomProbability <= HeadshotProbability)
        {
            Damage = CalculateHeadshotDamage(BaseDamage);
        }
    }
if (Damage == 0.f)
    {
        Damage = CalculateBaseDamage(BaseDamage);
    }

    return Damage;
}

float AMyWeapon::CalculateHeadshotDamage(float BaseDamage)
{
return BaseDamage * HeadshotMultiplier;
}

float AMyWeapon::CalculateBaseDamage(float BaseDamage)
{
return BaseDamage;
}
  
UPROPERTY(EditAnywhere, Category = "Weapon")
float FireRate;
bool AMyWeapon::CanFire()
{
return bReadyToFire;
}                                             

float MaxSniperAutoAimSpeed = GetDefault<UWeaponSettings>()->MaxSniperAutoAimSpeed;
float MaxFastTapSpeed = GetDefault<UInputSettings>()->GetAxisValue(FName("FastTapAxis"), 0.0f);

FHitResult HitResult;
FCollisionQueryParams Params;
Params.bTraceComplex = false;
Params.bReturnPhysicalMaterial = false;
bool bIsHit = GetWorld()->LineTraceSingleByProfile(HitResult, StartLocation, EndLocation, "FastDoorKnock", Params);
if (bIsHit)
{

void UMyGameUserSettings::LoadSettings(bool bForceReload)
{
false
    bEnableDizziness = false;
}

UPlayerInput* PlayerInput = GetMutableDefault<UPlayerInput>();
FInputActionKeyMapping* ActionMapping = PlayerInput->GetActionMappingByName("Zoom");

if (ActionMapping != nullptr)
{
PlayerInput->RemoveActionMapping(*ActionMapping);
}

UGameUserSettings* GameUserSettings = GetMutableDefault<UGameUserSettings>();

if (GameUserSettings != nullptr)
{
GameUserSettings->bDropProjectileOnEmptyClip = false;
}

UPROPERTY(EditAnywhere, Category = "Bullet")
float MaxScopedHeadshotMultiplier;
float CalculateScopedHeadshotMultiplier(float BaseMultiplier, float ScopeMultiplier);
float YourClassName::CalculateScopedHeadshotMultiplier(float BaseMultiplier, float ScopeMultiplier)
{
    return BaseMultiplier * ScopeMultiplier * MaxScopedHeadshotMultiplier;
}
float MaxAutoAimDistance = GetDefault<UPlayerInput>()->MaxAutoAimTargetDistance;
GetMutableDefault<UPlayerInput>()->MaxAutoAimTargetDistance = 10000.0f;

void AYourCharacter::BeginPlay()
{
    Super::BeginPlay();
UPhysicsSettings* PhysicsSettings = Cast<UPhysicsSettings>(UStaticSettings::GetTransientSettingsByName(TEXT("Physics")));

    if (PhysicsSettings)
    {
        HeadRadius = PhysicsSettings->HeadRadius;
    }
float HeadVolume = 4.0 / 3.0 * PI * FMath::Pow(HeadRadius, 3);
    UE_LOG(LogTemp, Warning, TEXT("headmodel：100%f"), HeadVolume);
}        
void AYourPlayerController::UpdateRotation(float DeltaTime)
{
    FRotator RotationInput = GetInputRotation();

    if (bIsFiring)
    {
        RotationInput *= 0.5f;
}

    Super::UpdateRotation(DeltaTime);
}        

void AYourPlayerController::UpdateRotation(float DeltaTime)
{
    FRotator RotationInput = GetInputRotation();

    if (bIsFiring && FMath::Abs(RotationInput.Pitch) > 0.0f)
    {
        RotationInput.Pitch *= 0.5f;
    }

    Super::UpdateRotation(DeltaTime);
}

void AYourPlayerController::UpdateRotation(float DeltaTime)
{
    FRotator RotationInput = GetInputRotation();

    if (bIsFiring && FMath::Abs(RotationInput.Yaw) > 0.0f)
    {
        RotationInput.Yaw *= 0.5f;
    }

    Super::UpdateRotation(DeltaTime);
}
void AYourPlayerController::UpdateCameraShake(float DeltaTime)
{
    // Get the current camera shake
    UCameraShake* CameraShake = GetCameraShake();

    if (CameraShake != nullptr)
    {
        // Customize the camera shake properties to reduce gyroscope shake
        CameraShake->OscillationBlendInTime = 0.2f;     // Adjust the blend-in time for a smoother transition
        CameraShake->OscillationBlendOutTime = 0.2f;    // Adjust the blend-out time for a smoother transition
        CameraShake->OscillationDuration = 0.5f;        // Adjust the duration of the camera shake
        CameraShake->OscillationBlendInAcceleration = 10.0f;    // Adjust the blend-in acceleration for a smoother transition
        CameraShake->OscillationBlendOutAcceleration = 10.0f;   // Adjust the blend-out acceleration for a smoother transition
    }

    Super::UpdateCameraShake(DeltaTime);
}
void AYourPlayerController::UpdateRotation(float DeltaTime)
{
    // Get the current rotation input
    FRotator RotationInput = GetInputRotation();

    if (bIsAimingDownSight)
    {
        // Scale down the rotation input for aiming down sight
        RotationInput.Pitch *= 0.5f;
        RotationInput.Yaw *= 0.5f;
        RotationInput.Roll *= 0.5f;
    }

    Super::UpdateRotation(DeltaTime);
}
void AYourPlayerController::UpdateCameraShake(float DeltaTime)
{
    // Get the current camera shake
    UCameraShake* CameraShake = GetCameraShake();

    if (CameraShake != nullptr)
    {
        // Check if the camera shake is caused by aiming down sight
        if (bIsAimingDownSight)
        {
            // Customize the camera shake properties for aiming down sight
            CameraShake->OscillationBlendInTime = 0.2f;     // Adjust the blend in time for a smoother transition
            CameraShake->OscillationBlendOutTime = 0.2f;    // Adjust the blend out time for a smoother transition
            CameraShake->OscillationDuration = 0.5f;        // Adjust the duration of the camera shake
            CameraShake->OscillationBlendInAcceleration = 10.0f;    // Adjust the blend in acceleration for a smoother transition
            CameraShake->OscillationBlendOutAcceleration = 10.0f;   // Adjust the blend out acceleration for a smoother transition
            CameraShake->FOVOscillation = FVOscillationParams();    // Disable FOV oscillation for aiming down sight
        }
    }

    Super::UpdateCameraShake(DeltaTime);
}
void AYourPlayerController::LookUpAtRate(float Rate)
{
    // Smooth the rate input
    Rate = SmoothInput(Rate);

    // Apply the smooth input to rotate the camera
    AddPitchInput(Rate * BaseLookRate * GetWorld()->DeltaTimeSeconds);
}

void AYourPlayerController::TurnAtRate(float Rate)
{
    // Smooth the rate input
    Rate = SmoothInput(Rate);

    // Apply the smooth input to rotate the camera
    AddYawInput(Rate * BaseTurnRate * GetWorld()->DeltaTimeSeconds);
}

float AYourPlayerController::SmoothInput(float Input)
{
    // Adjust the smoothing factor based on your preference
    float SmoothFactor = 0.2f;

    // Apply a simple linear interpolation to smooth the input
    float SmoothedInput = FMath::Lerp(LastInput, Input, SmoothFactor);

    // Store the current input for the next frame
    LastInput = SmoothedInput;

    return SmoothedInput;
}

UCLASS()
class YOURPROJECT_API AYourProjectileClass : public AActor
{
    GENERATED_BODY()
public:
AYourProjectileClass();
protected:
virtual void BeginPlay() override;
UFUNCTION()
    void OnHit(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit);
    UFUNCTION()
    void OnBeginOverlap(AActor* OverlappedActor, AActor* OtherActor);
private:
UPROPERTY(VisibleAnywhere)
    UBoxComponent* CollisionComponent;
UPROPERTY(VisibleAnywhere)
    UBoxComponent* TriggerComponent;
float AirHitRange = 20.0f;
};
AYourProjectileClass::AYourProjectileClass()
{
    PrimaryActorTick.bCanEverTick = false;
CollisionComponent = CreateDefaultSubobject<UBoxComponent>(TEXT("CollisionComponent"));
    RootComponent = CollisionComponent;
    CollisionComponent->SetCollisionProfileName(TEXT("20x20AirHit"));
TriggerComponent = CreateDefaultSubobject<UBoxComponent>(TEXT("TriggerComponent"));
    TriggerComponent->SetupAttachment(RootComponent);
    TriggerComponent->SetCollisionProfileName(TEXT("Trigger"));
    TriggerComponent->OnComponentBeginOverlap.AddDynamic(this, &AYourProjectileClass::OnBeginOverlap);
}

void AYourProjectileClass::BeginPlay()
{
    Super::BeginPlay();
CollisionComponent->OnComponentHit.AddDynamic(this, &AYourProjectileClass::OnHit);
}

void AYourProjectileClass::OnHit(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit)
{
    if (OtherActor && OtherActor != this && OtherActor->GetClass()->IsChildOf(AYourTargetClass::StaticClass()))
    {
void AYourProjectileClass::OnBeginOverlap(AActor* OverlappedActor, AActor* OtherActor)
{
    if (OtherActor && OtherActor != this && OtherActor->GetClass()->IsChildOf(AYourTargetClass::StaticClass()))
    {
FVector ProjectileLocation = GetActorLocation();
        FVector TargetLocation = OtherActor->GetActorLocation();
        if ((TargetLocation - ProjectileLocation).SizeSquared() > AirHitRange * AirHitRange)
        {
UCLASS()
class YOURPROJECT_API AYourProjectileClass : public AActor
{
    GENERATED_BODY()
public:
AYourProjectileClass();
protected:       
virtual void BeginPlay() override;
UFUNCTION()
    void OnHit(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit);
    UFUNCTION()
    void OnBeginOverlap(AActor* OverlappedActor, AActor* OtherActor);
private:
UPROPERTY(VisibleAnywhere)
    UBoxComponent* CollisionComponent;
UPROPERTY(VisibleAnywhere)
    UBoxComponent* TriggerComponent;
float HitRange = 20.0f;
};
AYourProjectileClass::AYourProjectileClass()
{
    PrimaryActorTick.bCanEverTick = false;
CollisionComponent = CreateDefaultSubobject<UBoxComponent>(TEXT("CollisionComponent"));
    RootComponent = CollisionComponent;
    CollisionComponent->SetCollisionProfileName(TEXT("20x20Hit"));
TriggerComponent = CreateDefaultSubobject<UBoxComponent>(TEXT("TriggerComponent"));
    TriggerComponent->SetupAttachment(RootComponent);
    TriggerComponent->SetCollisionProfileName(TEXT("Trigger"));
    TriggerComponent->OnComponentBeginOverlap.AddDynamic(this, &AYourProjectileClass::OnBeginOverlap);
}

void AYourProjectileClass::BeginPlay()
{
    Super::BeginPlay();
CollisionComponent->OnComponentHit.AddDynamic(this, &AYourProjectileClass::OnHit);
}

void AYourProjectileClass::OnHit(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit)
{
    if (OtherActor && OtherActor != this && OtherActor->GetClass()->IsChildOf(AYourTargetClass::StaticClass()))
    {
void AYourProjectileClass::OnBeginOverlap(AActor* OverlappedActor, AActor* OtherActor)
{
    if (OtherActor && OtherActor != this && OtherActor->GetClass()->IsChildOf(AYourTargetClass::StaticClass()))
    {
FVector ProjectileLocation = GetActorLocation();
        FVector TargetLocation = OtherActor->GetActorLocation();
        if ((TargetLocation - ProjectileLocation).SizeSquared() <= HitRange * HitRange)
        { 
        
void AYourProjectileClass::Tick(float DeltaSeconds)
{
    Super::Tick(DeltaSeconds);
    if (bBulletTrackingEnabled)
    {
FVector BulletLocation = GetActorLocation();
TArray<AEnemyCharacter*> Enemies;
AEnemyCharacter* TargetEnemy = FindTargetEnemy(Enemies, BulletLocation, BulletTrackingRadius);
        if (TargetEnemy)
        {
FVector TargetDirection = (TargetEnemy->GetActorLocation() - BulletLocation).GetSafeNormal();
FRotator TargetRotation = TargetDirection.Rotation();
            SetActorRotation(TargetRotation);
        }
    }
}
AEnemyCharacter* AYourProjectileClass::FindTargetEnemy(const TArray<AEnemyCharacter*>& Enemies, const FVector& BulletLocation, float Radius)
{
float MinDistance = Radius;
    AEnemyCharacter* TargetEnemy = nullptr;

    for (AEnemyCharacter* Enemy : Enemies)
    {
        float Distance = (Enemy->GetActorLocation() - BulletLocation).Size();
        if (Distance <= Radius && Distance < MinDistance)
        {
            MinDistance = Distance;
            TargetEnemy = Enemy;
        }
    }
    return TargetEnemy;
}                                                                            
void AYourPlayerController::Tick(float DeltaSeconds)
{
    Super::Tick(DeltaSeconds);

    if (bWallDetectionEnabled && IsWallDetected())
    {
FVector ControllerLocation = GetControlledPawn()->GetActorLocation();
        FRotator ControllerRotation = GetControlRotation();
TArray<AEnemyCharacter*> Enemies;
AEnemyCharacter* NearestEnemy = FindNearestEnemy(Enemies);
if (NearestEnemy && (NearestEnemy->GetActorLocation() - ControllerLocation).Size() <= WallDetectionDistance)
        {
FRotator AimRotation = (NearestEnemy->GetActorLocation() - ControllerLocation).Rotation();
            SetControlRotation(AimRotation);
        }
    }
}

bool AYourPlayerController::IsWallDetected()
{                    

void AYourProjectile::OnHit(AActor* OtherActor, UPrimitiveComponent* OtherComp, FVector NormalImpulse, const FHitResult& Hit)
{
    Super::OnHit(OtherActor, OtherComp, NormalImpulse, Hit);
    if (OtherActor && OtherComp)
    {
    
void AYourPlayerController::SetResolution(int32 Width, int32 Height)
{
    UGameViewportClient* ViewportClient = GEngine->GameViewport;
FViewportOptionCompositeData& ViewportOptions = ViewportClient->GetCurrentCompositeMode();
ViewportOptions.SetScreenResolution(FIntPoint(Width, Height));
ViewportClient->OnViewportResized();
}        
FRotator NewControllerRot = GetControlRotation();
NewControllerRot.Roll = 0.0f;
SetControlRotation(NewControllerRot);
PlayerInput->bEnableTouchEvents = true;
PlayerInput->bEnableMouseOverEvents = true;
PlayerInput->bEnableGamepadEvents = true;
PlayerInput->bEnableMotionControllerEvents = true;
PlayerInput->bEnableGyroscopeAutoLock = true

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "MyIniFile.generated.h"

UCLASS()
class MYPROJECT_API AMyIniFile : public AActor
{
    GENERATED_BODY()

public:
    // Sets default values for this actor's properties
    AMyIniFile();

protected:
    // Called when the game starts or when spawned
    virtual void BeginPlay() override;

public:    
    // Called every frame
    virtual void Tick(float DeltaTime) override;

    UFUNCTION(BlueprintCallable, Category = "Ini File")
    static FString ReadIniString(FString Section, FString Key, FString FilePath);

    UFUNCTION(BlueprintCallable, Category = "Ini File")
    static bool WriteIniString(FString Section, FString Key, FString Value, FString FilePath);

    UFUNCTION(BlueprintCallable, Category = "Ini File")
    static int32 ReadIniInt(FString Section, FString Key, FString FilePath);

    UFUNCTION(BlueprintCallable, Category = "Ini File")
    static bool WriteIniInt(FString Section, FString Key, int32 Value, FString FilePath);

    UFUNCTION(BlueprintCallable, Category = "Ini File")
    static float ReadIniFloat(FString Section, FString Key, FString FilePath);

    UFUNCTION(BlueprintCallable, Category = "Ini File")
    static bool WriteIniFloat(FString Section, FString Key, float Value, FString FilePath);
};
UPROPERTY(EditDefaultsOnly, Category = "Camera")
float MaxCameraDistance = 1000.f;
APlayerController::InitializeForLocalPlayer();
if (Player)
{
Player->PlayerCameraManager->bEnableFovScaling = true;
    Player->PlayerCameraManager->FovScalingFactor = 0.f;
Player->PlayerCameraManager->GetCameraLens()->SetMaxDrawDistance(MaxCameraDistance);
}    
UPROPERTY(EditDefaultsOnly, Category = "Weapon")
bool bEnableLongRangeScopeRecoil;

UPROPERTY(EditDefaultsOnly, Category = "Weapon", meta = (EditCondition = "bEnableLongRangeScopeRecoil"))
float LongRangeScopeRecoilValue;

class AMyPawn : public APawn
{
public:
    AMyPawn()
    {
        GetCharacterMovement()->SetJumpAllowed(false);
    }
}