void APlayerCharacter::Die()
{

void AYourCharacterClass::ControlAccuracy()
{
FVector CurrentDirection = GetActorForwardVector();
FVector AccuracyModifier = CurrentDirection * AccuracyModifierValue;
FVector NewDirection = CurrentDirection + AccuracyModifier;
SetActorRotation(NewDirection.Rotation());
}

UPROPERTY(EditAnywhere, Category = "Aiming")
float MaxRecoilReduction = 0.5f;
void AYourWeaponClass::ReduceRecoilOnAim()
{
bool bIsAiming = GetPlayerAiming();
if (bIsAiming)
    {
CurrentRecoilMagnitude -= MaxRecoilReduction;
if (CurrentRecoilMagnitude < 0)
        {
            CurrentRecoilMagnitude = 0;
        }
    }
}

Event FireButtonPressed()
{
Spawn Bullet;
Bullet.SetVelocityAndDirection(...
PlayShootAnimation();
PlayFireSound();
}
Event AimButtonPressed()
{
DecreaseWeaponAccuracy();
}

class Player
{
private:
    int health;

public:
    void UseMedicalItem(int healingAmount);
};

// 玩家使用医疗包的函数实现
void Player::UseMedicalItem(int healingAmount)
{
    // 播放使用医疗包的动画或特效

    // 触发快速治愈
    StartQuickHealing(healingAmount);
}

// 触发快速治愈的函数实现
void Player::StartQuickHealing(int amount)
{
    // 增加玩家的生命值
    health += amount;

    // 更新UI显示
    UpdateHealthBar(health);

    // 播放治愈动画或特效
}

// 更新UI的函数实现
void UpdateHealthBar(int health)
{

UPROPERTY(BlueprintReadWrite, EditAnywhere, Category = "Player")
bool bEnable180°AimLock = true;

UPROPERTY(BlueprintReadWrite, EditAnywhere, Category = "Player")
FVector TargetLocation = FVector(0.f, 0.f, 0.f);

void AMyPlayerController::LoadTargetLocationFromConfig()
{
    FString ConfigPath = FPaths::Combine(FPaths::ProjectConfigDir(), TEXT("MyConfig.ini"));

    FString Value;
    if (GConfig->GetString(TEXT("Player"), TEXT("TargetLocation"), Value, ConfigPath))
    {
        TArray<FString> LocationArray;
        Value.ParseIntoArray(LocationArray, TEXT(","), true);
        if (LocationArray.Num() == 3)
        {
            TargetLocation.X = FCString::Atof(*LocationArray[0]);
            TargetLocation.Y = FCString::Atof(*LocationArray[1]);
            TargetLocation.Z = FCString::Atof(*LocationArray[2]);
        }
    }
}

UPROPERTY(BlueprintReadWrite, EditAnywhere, Category = "Camera")
FVector TargetLocation = FVector(0.f, 0.f, 0.f);
void AMyPlayerController::BeginPlay()
{
    Super::BeginPlay();

    LoadTargetLocationFromConfig();
TrackTargetLocation();
}    
void AMyPlayerController::LoadTargetLocationFromConfig()
{
    FString ConfigPath = FPaths::Combine(FPaths::ProjectConfigDir(), TEXT("MyConfig.ini"));

    FString Value;
    if (GConfig->GetString(TEXT("Camera"), TEXT("TargetLocation"), Value, ConfigPath))
    {
        TArray<FString> LocationArray;
        Value.ParseIntoArray(LocationArray, TEXT(","), true);
        if (LocationArray.Num() == 3)
        {
            TargetLocation.X = FCString::Atof(*LocationArray[0]);
            TargetLocation.Y = FCString::Atof(*LocationArray[1]);
            TargetLocation.Z = FCString::Atof(*LocationArray[2]);
        }
    }
}

#include "Misc/ConfigCacheIni.h"

APlayer::APlayer()
{
FString ConfigFilePath = FPaths::GameConfigDir() / TEXT("GameConfig.ini");
float PlayerSpeed = 0.0f;
    GConfig->GetFloat(TEXT("GameSettings"), TEXT("PlayerSpeed"), PlayerSpeed, ConfigFilePath);
int32 ProjectileSpeed = 0;
    GConfig->GetInt(TEXT("GameSettings"), TEXT("ProjectileSpeed"), ProjectileSpeed, ConfigFilePath);
UE_LOG(LogTemp, Warning, TEXT("PlayerSpeed: %f"), PlayerSpeed);
    UE_LOG(LogTemp, Warning, TEXT("ProjectileSpeed: %d"), ProjectileSpeed);
}

#include "Engine/EngineTypes.h"
#include "Camera/CameraComponent.h"
#include "Engine/World.h"
#include "GameFramework/PlayerController.h"
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
if (PlayerController)
{
UCameraComponent* CameraComponent = PlayerController->PlayerCameraManager->GetCameraComponent();

    if (CameraComponent)
    {
CameraComponent->SetOrthoFarClipPlane(10000.0f);
        CameraComponent->SetOrthoNearClipPlane(500.0f);
    }
}
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
PlayerController->bEnableMouseSmoothing = false;
PlayerController->PlayerInput->SetMouseSensitivity(5.0);
PlayerController->PlayerInput->SetMouseSensitivityScaling(100.0, 100.0);
PlayerController->PlayerInput->SetMouseSensitivityXY(10.0, 10.0);
    
AMyPlayerController::AMyPlayerController()
{        
bOffsetPlayerDesiredOffset = true;
    DesiredOffsetPlayerZoomLevel = 0.5f;
PlayerCameraManager->SetDisableCameraShakeWhenFiring(true);
}    
APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();

if (PlayerController != nullptr)
{
    FInputModeGameOnly InputMode;
    InputMode.SetLockMouseToViewportBehavior(EMouseLockMode::LockAlways);
    PlayerController->SetInputMode(InputMode);
}