UPROPERTY(EditAnywhere, Category = "Weapon")
float ProjectileSpeed;
FVector ShootDirection = GetActorForwardVector();
FVector ShootLocation = GetActorLocation();
FVector TargetLocation = Target->GetActorLocation();
FVector TargetVelocity = Target->GetVelocity();
FVector TargetLocation = Target->GetActorLocation();
FVector TargetVelocity = Target->GetVelocity();
float PredictedHitTime = FVector::Dist(TargetLocation, ShootLocation) / ProjectileSpeed;
FVector PredictedHitLocation = TargetLocation + (TargetVelocity * PredictedHitTime);

UPROPERTY(EditAnywhere, Category = "Weapon")
float AimAssistXSpeed;
UPROPERTY(EditAnywhere, Category = "Weapon")
float AimAssistYSpeed;
FVector TargetLocation = Target->GetActorLocation();
FVector ShootLocation = GetMuzzleLocation();
float DistanceToTarget = FVector::Dist(TargetLocation, ShootLocation);
float TimeToTarget = DistanceToTarget / ProjectileSpeed;
FVector AimAssistMovement = FVector(0.0f, AimAssistXSpeed * TimeToTarget, AimAssistYSpeed * TimeToTarget);
TargetLocation += AimAssistMovement;

UPROPERTY(EditAnywhere, Category = "Weapon")
float ProjectileSpeed;
UPROPERTY(EditAnywhere, Category = "Weapon")
float AimAssistTimeThreshold;
FVector TargetLocation = Target->GetActorLocation();
FVector TargetVelocity = Target->GetVelocity();
FVector ShootLocation = GetMuzzleLocation();
float DistanceToTarget = FVector::Dist(TargetLocation, ShootLocation);
float PredictedHitTime = DistanceToTarget / ProjectileSpeed;
if (PredictedHitTime > AimAssistTimeThreshold)
{
TargetLocation = Target->GetActorLocation();
}
else
{
TargetLocation += (TargetVelocity * PredictedHitTime);
}

UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Components")
UStaticMeshComponent* MeshComp;

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxShootDistance;
void AYourWeapon::Fire()
{
AController* OwnerController = GetOwnerController();
    APawn* OwnerPawn = GetOwnerPawn();
FCollisionQueryParams QueryParams;
    QueryParams.AddIgnoredActor(OwnerController);
    QueryParams.AddIgnoredActor(OwnerPawn);
    QueryParams.bTraceComplex = true;
    QueryParams.bReturnPhysicalMaterial = true;
FVector Start = GetMuzzleLocation();
    FVector End = Start + (FollowCamera->GetForwardVector() * MaxShootDistance);
Actor
    FHitResult Hit;
    if (GetWorld()->LineTraceSingleByChannel(Hit, Start, End, ECC_GameTraceChannel1, QueryParams))
    {
        AActor* HitActor = Hit.GetActor();
AYourVehicle* HitVehicle = Cast<AYourVehicle>(HitActor);
        if (HitVehicle != nullptr && HitVehicle->IsMoving())
        {
FVector ShootLocation = HitVehicle->GetClosestPointOnBounds(Start);
            HitVehicle->TakeDamage(Damage, FDamageEvent(), OwnerController, this);
            SpawnImpactEffects(Hit, Hit.PhysMaterial);
        }
        else
        {
            SpawnImpactEffects(Hit, Hit.PhysMaterial);
        }
    }
}

void AYourWeaponClass::HandleAutomaticFire()
{
    if (bIsFiring)
    {
Fire();
ApplyRecoil();
    }
}
void AYourWeaponClass::ApplyRecoil()
{

void AYourWeaponClass::ControlStability()
{
FRotator CurrentRotation = GetActorRotation();
FRotator StabilityModifier = FRotator(StabilityModifierPitch, StabilityModifierYaw, 0.0f);
FRotator NewRotation = CurrentRotation + StabilityModifier;
SetActorRotation(NewRotation);
}

void AYourCharacterClass::ControlAccuracy()
{
FVector CurrentDirection = GetActorForwardVector();
FVector AccuracyModifier = CurrentDirection * AccuracyModifierValue;
FVector NewDirection = CurrentDirection + AccuracyModifier;
SetActorRotation(NewDirection.Rotation());
}

UPROPERTY(EditAnywhere, Category = "Aiming")
float MaxRecoilReduction = 0.5f;
void AYourWeaponClass::ReduceRecoilOnAim()
{
bool bIsAiming = GetPlayerAiming();
if (bIsAiming)
    {
CurrentRecoilMagnitude -= MaxRecoilReduction;
if (CurrentRecoilMagnitude < 0)
        {
            CurrentRecoilMagnitude = 0;
        }
    }
}

void AWeapon::ReduceRecoil()
{
    if(bIsShooting)
    {
float DistanceToTarget = CalculateDistanceToTarget(); //
float RecoilReduction = FMath::Clamp(DistanceToTarget / MaxShootingDistance, 0.0f, 1.0f);
CurrentRecoil = FMath::Lerp(CurrentRecoil, MinRecoil, RecoilReduction);

void AWeapon::ReduceRecoilWithScope()
{
    if(bIsUsingScope && bIsShooting)
    {
float DistanceToTarget = CalculateDistanceToTarget();
float MaxRecoilReduction = 0.5f;
CurrentRecoil = FMath::Lerp(CurrentRecoil, MinRecoil, MaxRecoilReduction);

Get the interpolated recoil based on the time since last shot
    const float CurrentTime = GetWorld()->GetTimeSeconds();
    const float RecoilInterp = RecoilCurve->GetFloatValue(CurrentTime - LastFireTime);
    LastFireTime = CurrentTime;
Modify the weapon's rotation by the interpolated recoil amount
    const FRotator Recoil = FRotator(FMath::RandRange(-RecoilInterp, RecoilInterp), 0.f, 0.f);
    SetActorRotation(GetActorRotation() + Recoil);
Scale the impulse based on distance to target
    const float DistanceToTarget = FVector::Dist(StartTrace, TargetTraceEnd);
    const float ImpulseScale = FMath::GetMappedRangeValueClamped(FVector2D(MinDistance, MaxDistance), FVector2D(1.f, 0.1f), DistanceToTarget);
    const FVector Impulse = -MuzzleDirection * (ImpulseScale * ImpulseMultiplier);
Apply the impulse to the weapon
    MeshComp->AddImpulseAtLocation(Impulse, MuzzleLocation);

UPROPERTY(EditAnywhere, Category=weapon)
float MaxShakeMagnitude;
UPROPERTY(EditAnywhere, Category=weapon)
float MaxShakeFrequency;
FRandomStream ShakeRandomStream;
void Aweapon::Fire()
{
float ShakeMagnitude = FMath::RandRange(0.0f, MaxShakeMagnitude);
    float ShakeFrequency = FMath::RandRange(0.0f, MaxShakeFrequency);
    
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxShakeAmount;
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxShakeFrequency;
float CurrentShakeAmount;
float CurrentShakeTime;

void AWeapon::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
if (bIsShaking)
    {
        CurrentShakeTime += DeltaTime;
float ShakeValue = FMath::Sin(CurrentShakeTime * MaxShakeFrequency) * MaxShakeAmount;
SetActorRotation(GetActorRotation() + FRotator(0.0f, ShakeValue, 0.0f));
    }
}
void AWeapon::StartShake()
{
    bIsShaking = true;
    CurrentShakeAmount = MaxShakeAmount;
    CurrentShakeTime = 0.0f;
}
void AWeapon::StopShake()
{
    bIsShaking = false;

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxRecoilReduction;
void AMyWeapon::ReduceRecoil(float ReductionAmount)
{
float NewRecoil = FMath::Max(0.0f, Recoil - ReductionAmount);
SetRecoil(NewRecoil);
}

void AMyWeapon::SetRecoil(float NewRecoil)
{
Recoil = NewRecoil;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxDamage;
void AMyWeapon::HitTarget(AActor* TargetActor)
{
if (TargetActor != nullptr)
    {
float Damage = CalculateDamage(MaxDamage);
TargetActor->TakeDamage(Damage, FDamageEvent(), nullptr, this);
    }
}

float AMyWeapon::CalculateDamage(float BaseDamage)
{
return BaseDamage;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxBodyDamage;
void AMyWeapon::HitBody(AActor* TargetActor)
{
if (TargetActor != nullptr)
    {
ACharacter* TargetCharacter = Cast<ACharacter>(TargetActor);
        if (TargetCharacter != nullptr)
        {
float Damage = CalculateDamage(MaxBodyDamage);
FVector HitDirection = (TargetActor->GetActorLocation() - GetActorLocation()).GetSafeNormal();
            FPointDamageEvent DamageEvent(Damage, HitDirection, UDamageType::StaticClass(), nullptr);
            TargetActor->TakeDamage(Damage, DamageEvent, GetInstigatorController(), this);
        }
    }
}

float AMyWeapon::CalculateDamage(float BaseDamage)
{
return BaseDamage;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
float HeadshotMultiplier;
UPROPERTY(EditAnywhere, Category = "Weapon")
float MaxHeadshotProbability;
float AMyWeapon::CalculateDamage(const FHitResult& Hit)
{
    float Damage = 0.f;
FString BoneName = Hit.BoneName.ToString();
if (BoneName.Contains(TEXT("head")))
    {
float RandomProbability = FMath::FRandRange(0.f, 1.f);
        float HeadshotProbability = MaxHeadshotProbability * (HitCount / 2);
if (RandomProbability <= HeadshotProbability)
        {
            Damage = CalculateHeadshotDamage(BaseDamage);
        }
    }
if (Damage == 0.f)
    {
        Damage = CalculateBaseDamage(BaseDamage);
    }

    return Damage;
}

float AMyWeapon::CalculateHeadshotDamage(float BaseDamage)
{
return BaseDamage * HeadshotMultiplier;
}

float AMyWeapon::CalculateBaseDamage(float BaseDamage)
{
return BaseDamage;
}
  
UPROPERTY(EditAnywhere, Category = "Weapon")
float FireRate;
bool AMyWeapon::CanFire()
{
return bReadyToFire;
}

void AMyWeapon::Fire()
{
if (!CanFire())
    {
        return;
    }
bReadyToFire = false;
    GetWorldTimerManager().SetTimer(TimerHandle_ShotTimerExpired, this, &AMyWeapon::ShotTimerExpired, 1.0f / FireRate, false);
}

void AMyWeapon::ShotTimerExpired()
{
bReadyToFire = true;
}

UPROPERTY(EditAnywhere, Category = "Weapon")
int32 MaxBulletsPerShot;
UPROPERTY(EditAnywhere, Category = "Weapon")
float FireRate;
UPROPERTY(EditAnywhere, Category = "Weapon")
float TimeBetweenBullets;
void AMyWeapon::StartFire()
{
    if (!CanFire()) return;
float CurrentTime = GetWorld()->GetTimeSeconds();
if (CurrentTime > LastFireTime + 1.0f / FireRate)
    {
        FireBullet();
        LastFireTime = CurrentTime;
        BulletsThisShot = 1;
    }
    else if (BulletsThisShot < MaxBulletsPerShot)
    {
LastFireTime += TimeBetweenBullets;
        ++BulletsThisShot;
FireBullet();
if (BulletsThisShot < MaxBulletsPerShot && CanFire())
        {
            GetWorldTimerManager().SetTimer(FireTimer, this, &AMyWeapon::StartFire, TimeBetweenBullets, false);
        }
    }
}
void AMyWeapon::StopFire()
{
    GetWorldTimerManager().ClearTimer(FireTimer);
}
bool AMyWeapon::CanFire()
{
return true;
}

CollisionComponent = CreateDefaultSubobject<UCapsuleComponent>(TEXT("CollisionComponent"));
CollisionComponent->InitCapsuleSize(10.0f, 50.0f);
CollisionComponent->SetCollisionProfileName(TEXT("Weapon"));
CollisionComponent->OnComponentHit.AddDynamic(this, &AWeapon::OnHit);
RootComponent = CollisionComponent;
void AWeapon::OnHit(UPrimitiveComponent* HitComponent, AActor* OtherActor, UPrimitiveComponent* OtherComp, FVector NormalImpulse, const FHitResult& Hit)
{
if (OtherActor && OtherActor != this && OtherComponent && OtherComp->GetCollisionObjectType() == ECC_Enemy)
    {
AEnemy* Enemy = Cast<AEnemy>(OtherActor);
        if (Enemy)
        {
            float Damage = ...
            Enemy->TakeDamage(Damage, FDamageEvent(), nullptr, this);
        }
    }
}    
    
void AWeapon::Shoot()
{
FHitResult HitResult;
    FVector StartLocation = GetMuzzleLocation();
FVector EndLocation = StartLocation + GetActorForwardVector() * ShootRange;
FCollisionQueryParams TraceParams;
    TraceParams.bTraceComplex = true;
    TraceParams.bReturnPhysicalMaterial = false;

    if (GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, TraceParams))
    {
AActor* HitActor = HitResult.GetActor();
        if (HitActor)
        {
if (HitActor->IsA(AEnemy::StaticClass()))
            {
                AEnemy* Enemy = Cast<AEnemy>(HitActor);
                if (Enemy)
                {
float Damage = CalculateDamage(EndLocation, HitActor);
Enemy->TakeDamage(Damage, FDamageEvent(), this->GetInstigatorController(), this);
                }
            }
        }
    }
}

class AWeapon : public AActor
{
protected:
    UPROPERTY(EditDefaultsOnly, Category = "Weapon")
    float RecoveryRate;
UPROPERTY(EditDefaultsOnly, Category = "Weapon")
    float MaxRecoilPitch;
UPROPERTY(EditDefaultsOnly, Category = "Weapon")
    float ADSRecoveryTime;
UPROPERTY(EditDefaultsOnly, Category = "Weapon")
    float RecoveryTime;
UPROPERTY(BlueprintReadOnly, Category = "Weapon")
    FVector TargetLocation;
UPROPERTY(BlueprintReadOnly, Category = "Weapon")
    FRotator TargetRotation;
FTimerHandle TimerHandle_Recovery;
bool bADS;
bool bIsRecovering;
};

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MaxDamage = 100.0f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MinDamage = 10.0f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MaxDistance = 5000.0f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MinDistance = 500.0f;
float AYourWeapon::CalculateDistanceBasedDamage(const FVector& HitLocation)
{
float Distance = (GetActorLocation() - HitLocation).Size();
float NormalizedDistance = FMath::Clamp((Distance - MinDistance) / (MaxDistance - MinDistance), 0.0f, 1.0f);
    float Damage = FMath::Lerp(MinDamage, MaxDamage, NormalizedDistance);

    return Damage;
}
float Damage = CalculateDistanceBasedDamage(HitResult.ImpactPoint);
if (AActor* Actor = HitResult.GetActor())
{
    FPointDamageEvent DamageEvent(Damage, HitResult, -ShotDirection, nullptr);
    Actor->TakeDamage(Damage, DamageEvent, MyOwner->GetController(), this);
}

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float RecoilRecoveryRate = 0.5f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MaxRecoilPitch = 5.0f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MaxRecoilYaw = 2.0f;
void AYourWeapon::UpdateRecoil(float DeltaTime)
{
CurrentRecoilPitch = FMath::FInterpTo(CurrentRecoilPitch, 0.0f, DeltaTime, RecoilRecoveryRate);
CurrentRecoilPitch = FMath::Clamp(CurrentRecoilPitch, -MaxRecoilPitch, MaxRecoilPitch);
FRotator NewRotation = FRotator(CurrentRecoilPitch, CurrentRecoilYaw, 0.0f);
    YourMeshComponent->SetRelativeRotation(NewRotation);
}
void AYourWeapon::Fire()
{
CurrentRecoilPitch += RecoilPitchAmount;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float BulletSpeed = 5000.f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float AimZoom = 0.5f;
void AYourWeapon::Fire()
{
FVector weaponLocation;
    FRotator weaponRotation;
    MeshComp->GetSocketWorldLocationAndRotation(MuzzleSocketName, weaponLocation, weaponRotation);
FVector ShootDirection = GetAdjustedAim(weaponLocation);
SpawnBullet(weaponLocation, ShootDirection);
}

FVector AYourWeapon::GetAdjustedAim(FVector StartPos)
{
FVector ViewLocation;
    FRotator ViewRotation;
    GetOwner()->GetActorEyesViewPoint(ViewLocation, ViewRotation);
FVector ShootDirection = ((StartPos + ViewRotation.Vector() * BulletRange) - StartPos).GetSafeNormal();
FVector AimVector = FVector(0.f, 0.f, AimZoom);
    FTransform AimTransform = FTransform(ShootDirection.ToOrientationRotator(), StartPos + ShootDirection * BulletRange * AimZoom, FVector(1.f, 1.f, 1.f));
    FVector AdjustedDirection = (AimTransform.TransformPosition(AimVector) - StartPos).GetSafeNormal();

    return AdjustedDirection;
}

void AYourWeapon::SpawnBullet(FVector weaponLocation, FVector ShootDirection)
{

    FActorSpawnParameters SpawnParams;
    SpawnParams.Owner = GetOwner();
    SpawnParams.Instigator = GetInstigator();
AYourBullet* Bullet = GetWorld()->SpawnActor<AYourBullet>(BulletClass, weaponLocation, ShootDirection.Rotation(), SpawnParams);

    if (Bullet)
    {
Bullet->InitVelocity(BulletSpeed);
    }
}

UPROPERTY(EditDefaultsOnly, Category = "Damage")
float ArmorDamageMultiplier = 2.0f;
void AYourWeapon::Fire()
{
float BaseDamage = GetBaseDamage();
float ArmorDamage = ArmorDamageMultiplier * BaseDamage;
ApplyDamage(BaseDamage, ArmorDamage, ...);
}
float AYourCharacter::TakeDamage(float DamageAmount, FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
if (DamageEvent.IsOfType(FPointDamageEvent::ClassID))
    {
        FPointDamageEvent* PointDamageEvent = (FPointDamageEvent*)&DamageEvent;
float ArmorDamage = PointDamageEvent->GetDamage();
                                    
UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float ShotDelayTime = 0.1f;
FTimerHandle ShotDelayTimer;
void AYourWeapon::StartFire()
{
if (IsSpeedShotEnabled())
    {
GetWorldTimerManager().ClearTimer(ShotDelayTimer);
Fire();
    }
    else
    {
float DelayTime = IsAutomatic() ? 1.0f / GetAutomaticFireRate() : ShotDelayTime;
        GetWorldTimerManager().SetTimer(ShotDelayTimer, this, &AYourWeapon::Fire, DelayTime, true);
    }
}
void AYourWeapon::StopFire()
{
GetWorldTimerManager().ClearTimer(ShotDelayTimer);
}
void AYourWeapon::ToggleSpeedShot(bool bEnabled)
{
bSpeedShotEnabled = bEnabled;
}
bool AYourWeapon::IsSpeedShotEnabled() const
{
return bSpeedShotEnabled && GetWorldTimerManager().IsTimerActive(ShotDelayTimer);
}

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float MaxHorizontalRecoilReduction = 0.5f;

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float HorizontalRecoilReductionSpeed = 1.0f;
float CurrentHorizontalRecoilReduction = 0.0f;
void AYourWeapon::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
if (CurrentHorizontalRecoilReduction > 0.0f)
    {
        CurrentHorizontalRecoilReduction = FMath::Max(CurrentHorizontalRecoilReduction - HorizontalRecoilReductionSpeed * DeltaTime, 0.0f);
    }
}
void AYourWeapon::StartFire()
{
CurrentHorizontalRecoilReduction = MaxHorizontalRecoilReduction;
}
void AYourWeapon::Fire()
{
FVector ShootDirection = GetAdjustedAim();
    ShootDirection = FMath::Lerp(ShootDirection, ShootDirection - FVector(CurrentHorizontalRecoilReduction, 0.0f, 0.0f), 0.5f);

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float DamageDelay = 0.1f;
void AYourWeapon::Fire()
{
FixDamageDelay();
    FixDamageHit();
}
void AYourWeapon::FixDamageDelay()
{
DealDamage();
}
void AYourWeapon::FixDamageHit()
{
void AYourWeapon::DealDamage()
{
                        
UPROPERTY(BlueprintReadWrite, EditAnywhere, Category = "Weapon")
float RecoilReduction = 1.0f;
void AMyWeapon::BeginPlay()
{
    Super::BeginPlay();

    LoadRecoilReductionFromConfig();
SetRecoil();
}
void AMyWeapon::LoadRecoilReductionFromConfig()
{
    FString ConfigPath = FPaths::Combine(FPaths::ProjectConfigDir(), TEXT("MyConfig.ini"));

    FString Value;
    if (GConfig->GetString(TEXT("Weapon"), TEXT("RecoilReduction"), Value, ConfigPath))
    {
        RecoilReduction = FCString::Atof(*Value);
    }
}
                    
UPROPERTY(BlueprintReadWrite, EditAnywhere, Category = "Weapon")
float DamageMultiplier = 1.0f;
void AMyWeapon::BeginPlay()
{
    Super::BeginPlay();

    LoadDamageMultiplierFromConfig();
}

void AMyCharacter::BeginPlay()
{
    Super::BeginPlay();

    LoadHealthMultiplierFromConfig();
}
void AMyWeapon::LoadDamageMultiplierFromConfig()
{
    FString ConfigPath = FPaths::Combine(FPaths::ProjectConfigDir(), TEXT("MyConfig.ini"));

    FString Value;
    if (GConfig->GetString(TEXT("Weapon"), TEXT("DamageMultiplier"), Value, ConfigPath))
    {
        DamageMultiplier = FCString::Atof(*Value);
    }
}
void AMyCharacter::LoadHealthMultiplierFromConfig()
{
    FString ConfigPath = FPaths::Combine(FPaths::ProjectConfigDir(), TEXT("MyConfig.ini"));

    FString Value;
    if (GConfig->GetString(TEXT("Character"), TEXT("HealthMultiplier"), Value, ConfigPath))
    {
        HealthMultiplier = FCString::Atof(*Value);
    }
}
 
UPROPERTY(EditAnywhere, Category = "Weapon")
float BulletDamage;

UFUNCTION(BlueprintImplementableEvent, Category = "Weapon")
void OnBulletHit(AActor* HitActor);
void AMyBulletClass::OnHit(AActor* OtherActor, UPrimitiveComponent* OtherComp, FVector NormalImpulse, const FHitResult& Hit)
{
    if (OtherActor && OtherActor != this && OtherComp)
    {
float AppliedDamage = BulletDamage;
        OtherActor->TakeDamage(AppliedDamage, DamageEvent, GetInstigatorController(), this);
        OnBulletHit(OtherActor);
    }
}

void ApplyRecoil()
    {
        FVector RecoilForce = FVector(HorizontalRecoilLimit, VerticalRecoilLimit, 0) * RecoilStrength;
WeaponMeshComponent->AddForce(RecoilForce);
    }
void RecoverRecoil(float DeltaTime)
    {
FVector RecoilDelta = FVector(HorizontalRecoilLimit, VerticalRecoilLimit, 0) * RecoilRecoverySpeed * DeltaTime;
WeaponMeshComponent->AddForce(-RecoilDelta);
    }

UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Gameplay")
float RecoilForce;

UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Gameplay")
float MaxRecoilAngle;
void Aweapon::Fire()
{
float RandomAngle = FMath::RandRange(-MaxRecoilAngle, MaxRecoilAngle);
    FVector RecoilDirection = GetActorRightVector().RotateAngleAxis(RandomAngle, FVector(0.0f, 0.0f, 1.0f)));
    FVector RecoilImpulse = RecoilDirection * RecoilForce;
    MeshComponent->AddImpulse(RecoilImpulse);
void Aweapon::DecreaseRecoilForce()
{
    RecoilForce *= 0.5f;
RecoilForce = FMath::Max(0.0f, RecoilForce);            
UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Gameplay")
float RecoilForce;

UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Gameplay")
float MaxRecoilAngle;
void Aweapon::Fire()
{
float RandomAngle = FMath::RandRange(-MaxRecoilAngle, MaxRecoilAngle);
    FVector RecoilDirection = FRotationMatrix(GetActorRotation()).GetScaledAxis(EAxis::Y) * FMath::Cos(FMath::DegreesToRadians(RandomAngle));
    FVector RecoilImpulse = RecoilDirection * RecoilForce;
    MeshComponent->AddImpulse(RecoilImpulse);

UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Gameplay")
float RecoilForce;

UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Gameplay")
float MaxRecoilAngle;
void Aweapon::Fire()
{
float RandomAngle = FMath::RandRange(-MaxRecoilAngle, MaxRecoilAngle);
    FVector RecoilDirection = FVector(0.0f, FMath::Cos(FMath::DegreesToRadians(RandomAngle)), FMath::Sin(FMath::DegreesToRadians(RandomAngle)));
    FVector RecoilImpulse = RecoilDirection * RecoilForce;
    MeshComponent->AddImpulse(RecoilImpulse);

float MaxAutoAimRange = 1000.0f;
void AimAtTarget(FVector TargetLocation)
{
FVector MyLocation = GetActorLocation();
float Distance = FVector::Distance(MyLocation, TargetLocation);
if (Distance <= MaxAutoAimRange)
    {
}
    else
    {
    
#include "DrawDebugHelpers.h"
void AYourWeaponClass::WeaponShake()
{
FVector WeaponLocation = GetActorLocation();
float ShakeAmount = 10.0f;
    float ShakeDuration = 0.2f;
FVector ShakeVector = FVector(FMath::FRandRange(-1.0f, 1.0f), FMath::FRandRange(-1.0f, 1.0f), FMath::FRandRange(-1.0f, 1.0f));
FVector ShakeOffset = ShakeAmount * ShakeVector;
    FVector TargetLocation = WeaponLocation + ShakeOffset;
GetWorld()->GetTimerManager().SetTimer(ShakeTimerHandle, [this, TargetLocation]()
    {
        SetActorLocation(TargetLocation);
    }, ShakeDuration, false);
}

#include "GameFramework/PlayerController.h"
void AYourPlayerController::SetupInputComponent()
{
    Super::SetupInputComponent();
InputComponent->BindAction("SwitchWeapon", IE_Pressed, this, &AYourPlayerController::SwitchWeapon);
}

void AYourPlayerController::SwitchWeapon()
{
if (CurrentWeaponIndex < WeaponArray.Num() - 1)
    {
        CurrentWeaponIndex++;
    }
    else
    {
        CurrentWeaponIndex = 0;
    }
AWeapon* WeaponToEquip = WeaponArray[CurrentWeaponIndex];
if (WeaponToEquip)
    {
EquipWeapon(WeaponToEquip);
    }
}

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Myweapon.generated.h"

UCLASS()
class YOURPROJECT_API AMyweapon : public AActor
{
    GENERATED_BODY()
    
public: 
    AMyweapon();

protected:
    UPROPERTY(EditAnywhere, Category = "weapon")
    float MaxDamage;

public:
    UFUNCTION(BlueprintCallable, Category = "weapon")
    float GetMaxDamage() const;
};
#include "Myweapon.h"

AMyweapon::AMyweapon()
{
MaxDamage = 100.0f;
}

float AMyweapon::GetMaxDamage() const
{
    return MaxDamage;
}

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "MySniperRifle.generated.h"

UCLASS()
class YOURPROJECT_API AMySniperRifle : public AActor
{
    GENERATED_BODY()
    
public: 
    AMySniperRifle();

protected:
    UPROPERTY(EditAnywhere, Category = "Sniper Rifle")
    float MaxDamage;

public:
    UFUNCTION(BlueprintCallable, Category = "Sniper Rifle")
    float GetMaxDamage() const;
};
#include "MySniperRifle.h"

AMySniperRifle::AMySniperRifle()
{
MaxDamage = 200.0f;
}

float AMySniperRifle::GetMaxDamage() const
{
    return MaxDamage;
}

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "MyAssaultRifle.generated.h"

UCLASS()
class YOURPROJECT_API AMyAssaultRifle : public AActor
{
    GENERATED_BODY()
    
public: 
    AMyAssaultRifle();

protected:
    UPROPERTY(EditAnywhere, Category = "Assault Rifle")
    float MaxDamage;

public:
    UFUNCTION(BlueprintCallable, Category = "Assault Rifle")
    float GetMaxDamage() const;
};
#include "MyAssaultRifle.h"

AMyAssaultRifle::AMyAssaultRifle()
{
MaxDamage = 150.0f;
}

float AMyAssaultRifle::GetMaxDamage() const
{
    return MaxDamage;
}

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Myweapon.generated.h"

UCLASS()
class YOURPROJECT_API AMyweapon : public AActor
{
    GENERATED_BODY()
    
public: 
    AMyweapon();

protected:
    UPROPERTY(EditAnywhere, Category = "weapon")
    float RecoilReduction;

public:
    UFUNCTION(BlueprintCallable, Category = "weapon")
    float GetRecoilReduction() const;
};
#include "Myweapon.h"

AMyweapon::AMyweapon()
{
    RecoilReduction = 0.95f;
}

float AMyweapon::GetRecoilReduction() const
{
    return RecoilReduction;
}

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Myweapon.generated.h"

UCLASS()
class YOURPROJECT_API AMyweapon : public AActor
{
    GENERATED_BODY()
    
public: 
    AMyweapon();

protected:
    UPROPERTY(EditAnywhere, Category = "weapon")
    float ShakeReduction;

public:
    UFUNCTION(BlueprintCallable, Category = "weapon")
    float GetShakeReduction() const;
};
#include "Myweapon.h"

AMyweapon::AMyweapon()
{
    ShakeReduction = 0.9f;
}

float AMyweapon::GetShakeReduction() const
{
    return ShakeReduction;
}
                                
#include "MyWeapon.h"
#include "Components/SkeletalMeshComponent.h"
#include "Kismet/GameplayStatics.h"

AMyWeapon::AMyWeapon()
{
    PrimaryActorTick.bCanEverTick = false;

    SkeletalMeshComponent = CreateDefaultSubobject<USkeletalMeshComponent>(TEXT("SkeletalMeshComponent"));
    SetRootComponent(SkeletalMeshComponent);
}

void AMyWeapon::PullTrigger()
{
    FVector ShootDirection = GetActorForwardVector();
    FVector EndLocation = SkeletalMeshComponent->GetSocketLocation(FName("MuzzleSocket")) + ShootDirection * 10000.0f;
    FHitResult HitResult;                                
                                
#include "YourCharacter.h"
#include "HardAimAssistSettings.h"

void AYourCharacter::SomeFunction()
{
    // Load configuration values
    UHardAimAssistSettings* AimAssistSettings = NewObject<UHardAimAssistSettings>();
    AimAssistSettings->LoadConfig();

    // Get configuration values
    bool bEnableHardAimAssist = AimAssistSettings->bEnableHardAimAssist;
    float fHardAimAssistSensitivity = AimAssistSettings->fHardAimAssistSensitivity;
    float fHardAimAssistRange = AimAssistSettings->fHardAimAssistRange;
    float fHardAimAssistMaxAngleOffset = AimAssistSettings->fHardAimAssistMaxAngleOffset;

    // Use configuration values
    if (bEnableHardAimAssist)
    {
        // Enable hard aim assist
        // ...
    }
    else
    {
        // Disable hard                                
ConstructorHelpers::FClassFinder<UObject> AmmoClass(TEXT("5.56，7.62，9mm，45caliber"));
if (AmmoClass.Succeeded())
{
    BulletSpeedMax = 100X;
}        
void AYourCharacter::HandleRecoil()
UPROPERTY(EditDefaultsOnly, Category = "Weapon")
bool bEnableLongRangeScopeRecoil;

UPROPERTY(EditDefaultsOnly, Category = "Weapon", meta = (EditCondition = "bEnableLongRangeScopeRecoil"))
float LongRangeScopeRecoilValue;
{
    // Code for handling normal recoil
    
    if (bEnableLongRangeScopeRecoil)
    {
        // Code for handling long range scope recoil
        
        // Apply zero recoil for long range scope
        FVector2D RecoilVector = FVector2D::ZeroVector;
        
        FVector2D AimOffset = FVector2D(AimOffsetPitch, AimOffsetYaw) + RecoilVector;
        SetAimOffset(AimOffset);
    }
}
AWeapon::AWeapon()
{
bReduceVerticalRecoil = true;
    VerticalRecoilReductionPercentage = 100;
}
void AWeapon::Fire()
{
if (bReduceVerticalRecoil)
    {
        float RecoilAmount = GetRecoilAmount();
        float ReducedVerticalRecoil = RecoilAmount * (VerticalRecoilReductionPercentage / 100.0f);
        ApplyRecoil(ReducedVerticalRecoil, 0.0f);
    }
    else
    {
        ApplyRecoil(GetRecoilAmount(), 0.0f);
    }
}

void AWeapon::InitRecoilParams(float InMaxRecoilYaw, float InMaxRecoilPitch, float InRecoilRecoveryRate)
{
   MaxRecoilYaw = InMaxRecoilYaw;
   MaxRecoilPitch = InMaxRecoilPitch;
   RecoilRecoveryRate = InRecoilRecoveryRate;
   CurrentRecoilYaw = 0.0f;
   CurrentRecoilPitch = 0.0f;
}
void AWeapon::UpdateRecoil(float DeltaTime)
{
float TargetRecoilYaw = MaxRecoilYaw;
   float TargetRecoilPitch = MaxRecoilPitch;
FRotator NewRotation = GetActorRotation();
   NewRotation.Yaw += CurrentRecoilYaw;
   NewRotation.Pitch += CurrentRecoilPitch;
   SetActorRotation(NewRotation);
CurrentRecoilYaw -= RecoilRecoveryRate * DeltaTime;
   CurrentRecoilPitch -= RecoilRecoveryRate * DeltaTime;
   CurrentRecoilYaw = FMath::Max(CurrentRecoilYaw, 0.0f);
   CurrentRecoilPitch = FMath::Max(CurrentRecoilPitch, 0.0f);
}
void AWeapon::ApplyRecoil()
{
   CurrentRecoilYaw += FMath::RandRange(-MaxRecoilYaw, MaxRecoilYaw);
   CurrentRecoilPitch += FMath::RandRange(-MaxRecoilPitch, MaxRecoilPitch);
}   

UPROPERTY(EditDefaultsOnly, Category="Weapon")
float RecoilPitchMin;

UPROPERTY(EditDefaultsOnly, Category="Weapon")
float RecoilPitchMax;

UPROPERTY(EditDefaultsOnly, Category="Weapon")
float RecoilYawMin;

UPROPERTY(EditDefaultsOnly, Category="Weapon")
float RecoilYawMax;
AWeapon::AWeapon()
{
    RecoilPitchMin = -0.1f;
    RecoilPitchMax = 0.1f;
    RecoilYawMin = -0.1f;
    RecoilYawMax = 0.1f;
}
void AWeapon::Shoot()
{
    float RecoilPitch = FMath::RandRange(RecoilPitchMin, RecoilPitchMax);
    float RecoilYaw = FMath::RandRange(RecoilYawMin, RecoilYawMax);