void AYourCharacter::CheckWallAimLock()
{
    FVector StartLocation = GetCameraLocation();
FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
    FCollisionQueryParams CollisionParams;
    CollisionParams.bTraceComplex = true;
    CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_WorldStatic, CollisionParams);

    if (HitResult.bBlockingHit)
    {
if (HitResult.Actor->IsA(ABaseWall::StaticClass()))
        {
            bWallAimLock = true;
        }
        else
        {
            bWallAimLock = false;
        }
    }
    else
    {
        bWallAimLock = false;
    }
}

USkeletalMeshComponent* MeshComp = GetMesh();
if (MeshComp)
{
    MeshComp->SetAnimInstanceClass(YourAnimInstanceClass);
    MeshComp->SetAnimInstancePoseSnapshot(YourPoseSnapshot, true);
    MeshComp->SetAnimationMode(EAnimationMode::AnimationBlueprint);

Blend Speed
    UAnimInstance* AnimInstance = MeshComp->GetAnimInstance();
    if (AnimInstance)
    {
        AnimInstance->GetAnimBlueprintGeneratedClass()->SetMetaDataOfClass(TEXT("BlendSpace"), TEXT("BlendSpeed"), TEXT("YourSpeedValue"));
    }
}

void AYourCharacter::CheckAutoHeadshot()
{
FVector StartLocation = GetCameraLocation();
    FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
    FCollisionQueryParams CollisionParams;
    CollisionParams.bTraceComplex = true;
    CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, CollisionParams);

    if (HitResult.bBlockingHit)
    {
ABaseEnemy* Enemy = Cast<ABaseEnemy>(HitResult.Actor);
        if (Enemy && Enemy->GetMesh()->FindClosestBone(HitResult.BoneName) == HeadBoneName)
        {
float Damage = MaxHealth * HeadshotMultiplier;
            FPointDamageEvent DamageEvent(Damage, HitResult, GetAimDirection(), UDamageType::StaticClass());
            Enemy->TakeDamage(Damage, DamageEvent, nullptr, this);
        }
    }
}

void AYourCharacter::CheckAutoHeadIcon()
{
FVector StartLocation = GetCameraLocation();
    FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
    FCollisionQueryParams CollisionParams;
    CollisionParams.bTraceComplex = true;
    CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, CollisionParams);

    if (HitResult.bBlockingHit)
    {
ABaseEnemy* Enemy = Cast<ABaseEnemy>(HitResult.Actor);
        if (Enemy && Enemy->GetMesh()->FindClosestBone(HitResult.BoneName) == HeadBoneName)
        {
        
void AYourCharacter::CheckAimHeadshot()
{
    if (IsAiming())
    {
FVector StartLocation = GetCameraLocation();
        FVector EndLocation = StartLocation + GetAimDirection() * MaxTraceDistance;
FHitResult HitResult;
        FCollisionQueryParams CollisionParams;
        CollisionParams.bTraceComplex = true;
        CollisionParams.AddIgnoredActor(this);
GetWorld()->LineTraceSingleByChannel(HitResult, StartLocation, EndLocation, ECC_Visibility, CollisionParams);

        if (HitResult.bBlockingHit)
        {
ABaseEnemy* Enemy = Cast<ABaseEnemy>(HitResult.Actor);
            if (Enemy && Enemy->GetMesh()->FindClosestBone(HitResult.BoneName) == HeadBoneName)
            {
YourWidgetInstance->SetHeadshotCrosshair(true);
if (AimTime >= HeadshotAimTime)
                {
float Damage = MaxHealth * HeadshotMultiplier;
                    FPointDamageEvent DamageEvent(Damage, HitResult, GetAimDirection(), UDamageType::StaticClass());
                    Enemy->TakeDamage(Damage, DamageEvent, nullptr, this);
YourWidgetInstance->ShowHeadshotEffect(HitResult.Location);
AimTime = 0.0f;
                }
                else
                {
AimTime += GetWorld()->GetDeltaSeconds();
                }
            }
            else
            {
YourWidgetInstance->SetHeadshotCrosshair(false);
                AimTime = 0.0f;
            }
        }
        else
        {
YourWidgetInstance->SetHeadshotCrosshair(false);
            AimTime = 0.0f;
        }
    }
}        
                    
protected:
    UPROPERTY(EditDefaultsOnly, Category = "Damage")
    float MaxHealth = 100.0f;
UPROPERTY(BlueprintReadOnly, Category = "Damage")
    float Health = MaxHealth;

float AYourCharacter::TakeDamage(float DamageAmount, FDamageEvent const& DamageEvent, AController* EventInstigator, AActor* DamageCauser)
{
    const float ActualDamage = Super::TakeDamage(DamageAmount, DamageEvent, EventInstigator, DamageCauser);

    if (ActualDamage > 0.0f)
    {
Health -= ActualDamage;
        if (Health <= 0.0f)
        {
Die();
        }
    }

    return ActualDamage;
}

void AYourCharacter::Die()
{

FPointDamageEvent DamageEvent(Damage, HitResult, GetAimDirection(), UDamageType::StaticClass());
HitedCharacter->TakeDamage(Damage, DamageEvent, InstigatorController, this);

Event BeginPlay()
{
SetCharacterMovementPrediction(true);
}

Event Tick(deltaTime)
{
Vector TargetLocation = GetPlayerTargetLocation();
if (bPredictiveMovement)
    {
        Vector PredictedLocation = PredictMovementLocation(TargetLocation);
InterpolateCharacterLocation(PredictedLocation, deltaTime);
    }
    else 
    {
        MoveCharacterTo(TargetLocation);
    }
}
                                          
GetCapsuleComponent()->SetCapsuleHalfHeight(50.f);
GetCapsuleComponent()->SetCapsuleRadius(25.f);
GetCapsuleComponent()->SetCollisionEnabled(ECollisionEnabled::QueryAndPhysics);               CollisionComponent = CreateDefaultSubobject<USphereComponent>(TEXT("SphereComponent"));
CollisionComponent->InitSphereRadius(15.0f);
CollisionComponent->SetCollisionProfileName(TEXT("Weapon"));
RootComponent = CollisionComponent; 

UWorld* World = GetWorld();
FHitResult HitResult;
FVector TraceStart = GetActorLocation();
FVector TraceEnd = AnotherActor->GetActorLocation();
FCollisionQueryParams Params(FName(TEXT("Trace")), true, this);
Params.bTraceComplex = true;
Params.bReturnPhysicalMaterial = true;
Params.AddIgnoredActor(this);
World->LineTraceSingleByChannel(HitResult, TraceStart, TraceEnd, ECollisionChannel::ECC_GameTraceChannel1, Params);
if (HitResult.Actor == AnotherActor)
{
float Distance = FVector::Distance(HitResult.ImpactPoint, TraceStart);
    float Damage = CalculateDamage(Distance);
    AnotherActor->TakeDamage(Damage, FDamageEvent(), nullptr, this);
}

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float BulletSpreadReduction = 0.5f;
void AYourWeapon::Fire()
{
MaxIncreaseBulletSpread();
}
IncreaseBulletSpread();
}
void AYourWeapon::IncreaseBulletSpread()
{
void AYourWeapon::MaxIncreaseBulletSpread()
{
float BulletSpread = GetCurrentBulletSpread();
BulletSpread *= BulletSpreadReduction;
SetCurrentBulletSpread(BulletSpread);
}

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float SightPitchRecoilReduction = 0.5f;
enum class EStance
{
    Standing,
    Crouching,
    Aiming
};
EStance CurrentStance;
void AYourWeapon::Fire()
{
if (CurrentStance == EStance::Aiming)
    {
ReduceSightPitchRecoil();
    }
}
void AYourCharacter::ReduceSightPitchRecoil()
{
FRotator SightRotator = GetSightRotation();
SightRotator.Pitch *= SightPitchRecoilReduction;
SetSightRotation(SightRotator);
}
void AYourCharacter::ChangeStance(EStance NewStance)
{
    CurrentStance = NewStance;
}

UPROPERTY(EditDefaultsOnly, Category = "Weapon")
float DamageDelay = 0.1f;    

UPROPERTY(BlueprintReadWrite, EditAnywhere, Category = "Character")
float HealthMultiplier = 1.0f;

float MaxLimbRange = 500.0f;
bool IsWithinLimbRange(FVector TargetLocation)
{
FVector MyLocation = GetActorLocation();
float Distance = FVector::Distance(MyLocation, TargetLocation);
if (Distance <= MaxLimbRange)
    {
return true;
    }
    else
    {
return false;
    }
}

void AYourCharacter::ApplyImpulseToCharacter()
{
FVector Impulse = FVector(1000.0f, 0.0f, 0.0f);
FVector Location = GetActorLocation();
GetCharacterMovement()->AddImpulse(Impulse);
}

float LongRangeDamageScale = 2.0f;
void OnAttack(FVector TargetLocation)
{
FVector MyLocation = GetActorLocation();
FVector AimDirection = (TargetLocation - MyLocation).GetSafeNormal();
    float Distance = FVector::Distance(TargetLocation, MyLocation);
float BaseDamage = GetBaseDamage();
    float Damage = BaseDamage;

    if (Distance > 1000.0f)
    {
Damage *= LongRangeDamageScale;
    }
    
float HeadshotDamageMultiplier = 2.0f;
void OnAttack(FVector HitLocation, bool IsHeadshot)
{
float DamageMultiplier = 1.0f;

    if (IsHeadshot)
    {
DamageMultiplier = HeadshotDamageMultiplier;
    }
float BaseDamage = GetBaseDamage();
    float Damage = BaseDamage * DamageMultiplier;
    
float BodyshotDamageMultiplier = 1.5f;
void OnAttack(FVector HitLocation, bool IsHeadshot)
{
float DamageMultiplier = 1.0f;

    if (!IsHeadshot)
    {
DamageMultiplier = BodyshotDamageMultiplier;
    }
float BaseDamage = GetBaseDamage();
    float Damage = BaseDamage * DamageMultiplier;
    
float FullbodyDamageMultiplier = 1.0f;
void OnAttack(FVector HitLocation, float DamageMultiplier)
{
float BaseDamage = GetBaseDamage();
    float Damage = BaseDamage * DamageMultiplier * FullbodyDamageMultiplier;
    
float MaxDamageMultiplier = 2.0f;
void OnAttack(FVector HitLocation, float DamageMultiplier)
{
float DynamicMaxDamageMultiplier = DamageMultiplier * MaxDamageMultiplier;
float BaseDamage = GetBaseDamage();
    float Damage = BaseDamage * DynamicMaxDamageMultiplier;
    
float AimOffset = 0.5f;
void OnAim(FVector TargetLocation)
{
FVector HeadLocation = GetHeadLocation();
FRotator LookRotation = UKismetMathLibrary::FindLookAtRotation(HeadLocation, TargetLocation);
    float AimPitch = LookRotation.Pitch - GetActorRotation().Pitch;
AimPitch *= AimOffset;
FRotator NewRotation = GetActorRotation();
    NewRotation.Pitch += AimPitch;
    SetActorRotation(NewRotation);
}

#include "HeadAimingCharacter.h"
void AHeadAimingCharacter::OnAim(float DeltaTime)
{
FVector GyroInput = FVector(GetInputAnalogKeyState(EKeys::GyroX), GetInputAnalogKeyState(EKeys::GyroY), GetInputAnalogKeyState(EKeys::GyroZ));
FRotator CurrentRotation = GetActorRotation();
    FRotator NewRotation = CurrentRotation + GyroInput * DeltaTime * GyroSensitivity;
    SetActorRotation(NewRotation);
}

RadialForceComponent
UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category="Force")
URadialForceComponent* RadialForceComponent;
ASuperRangeObject::ASuperRangeObject(const FObjectInitializer& ObjectInitializer)
    : Super(ObjectInitializer)
{
RadialForceComponent = ObjectInitializer.CreateDefaultSubobject<URadialForceComponent>(this, TEXT("RadialForceComponent"));    
RadialForceComponent->ImpulseStrength = 1000.f;
    RadialForceComponent->ForceStrength = 2000.f;
RadialForceComponent->AttachToComponent(RootComponent, FAttachmentTransformRules::KeepRelativeTransform);
}
RadialForceComponent->AttachToComponent(RootComponent, FAttachmentTransformRules::KeepRelativeTransform);
} 
void ASuperRangeObject::OnExplode()
{   
RadialForceComponent->FireImpulse();
}

GetCapsuleComponent()->InitCapsuleSize(DefaultCapsuleRadius, DefaultCapsuleHalfHeight);
GetMeshComponent()->SetCollisionEnabled(ECollisionEnabled::NoCollision);
GetMeshComponent()->SetCollisionProfileName(TEXT("NoCollision"));
void AMyCharacter::TakeDamage(float Damage)
{
if (bIsHit)
    {
GetCapsuleComponent()->SetCapsuleSize(ExpandedCapsuleRadius, ExpandedCapsuleHalfHeight);
GetMeshComponent()->SetCollisionEnabled(ECollisionEnabled::QueryAndPhysics);
        GetMeshComponent()->SetCollisionProfileName(TEXT("BlockAll")); 
    }
    else
    {

GetCapsuleComponent()->InitCapsuleSize(DefaultCapsuleRadius, DefaultCapsuleHalfHeight);
void AMyCharacter::TakeDamage(float Damage)
{
    Super::TakeDamage(Damage);
if (bIsHit)
    {
GetCapsuleComponent()->SetCapsuleSize(ExpandedCapsuleRadius, ExpandedCapsuleHalfHeight);
    }
    else
    {                
    
float BaseFOV;
float ZoomedFOV;
float CurrentFOV;
BaseFOV = 90.f;
ZoomedFOV = 30.f;
CurrentFOV = BaseFOV;
if (GetWorld()->GetFirstPlayerController()->PlayerCameraManager != nullptr)
{
CurrentFOV = FMath::FInterpTo(CurrentFOV, ZoomedFOV, DeltaTime, ZoomSpeed);
}
    else if (bZoomingOut)
    {
        CurrentFOV = FMath::FInterpTo(CurrentFOV, BaseFOV, DeltaTime, ZoomSpeed);
    }
GetWorld()->GetFirstPlayerController()->PlayerCameraManager->SetFOV(CurrentFOV);
}

void AYourCharacter::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
    Super::SetupPlayerInputComponent(PlayerInputComponent); 
PlayerInputComponent->BindAxis("MoveForward", this, &AYourCharacter::MoveForward);
    PlayerInputComponent->BindAxis("MoveRight", this, &AYourCharacter::MoveRight);
    PlayerInputComponent->BindAction("Sprint", IE_Pressed, this, &AYourCharacter::StartSprinting);
    PlayerInputComponent->BindAction("Sprint", IE_Released, this, &AYourCharacter::StopSprinting);
}

void AYourCharacter::MoveForward(float Val)
{
    if (Controller && Val != 0.0f)
    {
const FRotator Rotation = Controller->GetControlRotation();
        const FRotator YawRotation(0, Rotation.Yaw, 0);
const FVector Direction = FRotationMatrix(YawRotation).GetUnitAxis(EAxis::X);
GetCharacterMovement()->AddInputVector(Velocity);
    }
}

void AYourCharacter::MoveRight(float Val)
{
    if (Controller && Val != 0.0f)
    {
const FRotator Rotation = Controller->GetControlRotation();
        const FRotator YawRotation(0, Rotation.Yaw, 0);
const FVector Direction = FRotationMatrix(YawRotation).GetUnitAxis(EAxis::Y);
const FVector Velocity = Direction * Val * (bIsSprinting ? SprintSpeed : WalkSpeed);
GetCharacterMovement()->AddInputVector(Velocity);
    }
}

void AYourCharacter::StartSprinting()
{
    bIsSprinting = true;
}

void AYourCharacter::StopSprinting()
{
    bIsSprinting = false;
}

#include "MyCharacter.h"
#include "Components/CapsuleComponent.h"

AMyCharacter::AMyCharacter()
{
GetCapsuleComponent()->SetCapsuleRadius(100.0f);
    GetCapsuleComponent()->SetCapsuleHalfHeight(120.0f);                                                            
#include "GameFramework/SpringArmComponent.h"
#include "Camera/CameraComponent.h"             
ASomeCharacter::ASomeCharacter()
{
SpringArmComponent = CreateDefaultSubobject<USpringArmComponent>(TEXT("SpringArmComponent"));
    SpringArmComponent->SetupAttachment(RootComponent);
    SpringArmComponent->bUsePawnControlRotation = true;
CameraComponent = CreateDefaultSubobject<UCameraComponent>(TEXT("CameraComponent"));
    CameraComponent->SetupAttachment(SpringArmComponent);
}
void ASomeCharacter::Tick(float DeltaTime)
{
    Super::Tick(DeltaTime);
float GyroX = GetInputAxisValue("LockOnX");
    float GyroY = GetInputAxisValue("LockOnY");
FRotator ControlRotation = GetControlRotation();
    ControlRotation.Pitch += GyroY;
    ControlRotation.Yaw += GyroX;
    SetControlRotation(ControlRotation);
}             