#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "CoverSystem.generated.h"

UCLASS()
class YOURPROJECT_API ACoverSystem : public AActor
{
    GENERATED_BODY()

public: 
    ACoverSystem();

protected:
    virtual void BeginPlay() override;

public: 
    virtual void Tick(float DeltaTime) override;

    UFUNCTION(BlueprintCallable)
    void CheckCoverHit(AActor* Shooter, AActor* Target, FVector ShootDirection);

private:
    float CoverCheckDistance = 1000.f;
    float CoverCheckRadius = 50.f;
};
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "GridDamageActor.generated.h"

UCLASS()
class MYGAME_API AGridDamageActor : public AActor
{
    GENERATED_BODY()

public: 
    AGridDamageActor();

protected:
    virtual void BeginPlay() override;
public: 
    virtual void Tick(float DeltaTime) override;

    UPROPERTY(VisibleAnywhere)
    UStaticMeshComponent* MeshComponent;

    UPROPERTY(EditAnywhere)
    float DamageAmount;

    UFUNCTION()
    void OnMeshHit(AActor* SelfActor, AActor* OtherActor, FVector NormalImpulse, const FHitResult& Hit);
};
UPROPERTY(EditAnywhere, Category = "Combat")
float DamageInterval = 0.5f

#include "GameFramework/Actor.h"
#include "Components/BoxComponent.h"