#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "BulletJumpControl.generated.h"

UCLASS()
class YOURPROJECT_API ABulletJumpControl : public ACharacter
{
    GENERATED_BODY()

public:
    virtual void BeginPlay() override;
    virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

protected:
    UFUNCTION()
    void OnJumpKeyPressed();

    UFUNCTION()
    void OnCharacterMovementUpdated(float DeltaSeconds, const FVector& OldLocation, const FVector& OldVelocity);
    
private:
    void LoadJumpSettings();
    int32 MaxJumpCount; 
    float JumpForce;
    float JumpDelay;
    float JumpDelayTimer;
    bool bJumpKeyPressed;
};