#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "YourCharacter.generated.h"

UCLASS()
class YOURGAME_API AYourCharacter : public ACharacter
{
    GENERATED_BODY()

public:
    AYourCharacter();
    UFUNCTION(BlueprintPure, Category = "Damage")
    float GetMaxDamage() const;
    UFUNCTION(BlueprintCallable, Category = "Damage")
    void ApplyDamage(float DamageAmount);

protected:
    UPROPERTY(EditDefaultsOnly, Category = "Damage")
    float MaxDamage;
};
UPROPERTY(EditAnywhere, BlueprintReadWrite, Category=Collision)
float StandupCollisionRadius = 50.0f;
UFUNCTION(Server, Reliable, WithValidation)
void ServerNotifyHit(FHitResult HitResult);
UPROPERTY(EditAnywhere, Category = "Aiming")
float AimingSpreadIncreaseRate;