#include "MyCharacter.h"
#include "Components/SkeletalMeshComponent.h"
#include "Components/InputComponent.h"
#include "Camera/CameraComponent.h"
#include "MyCharacter.h"
AMyCharacter::AMyCharacter()
{
   FullDamage = 10000.0f;
   GunHitDamageMax=true
   bGunHitDamageMax=true
}
void AMyCharacter::SetFullDamage(float MaxDamage)
{
   FullDamage = MaxDamage;
}
float AMyCharacter::GetFullMaxDamage() const
{
   return FullMaxDamage;
}
void AMyCharacter::TakeDamage(float MaxDamageAmount)
{
   float TotalMaxDamage = MaxDamageAmount * FullMaxDamage;
   UFUNCTION(BlueprintCallable, Category = "Headshot")
void HandleHeadshotDamage(float DamageAmount, FVector HitFromDirection);
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "MyCharacter.generated.h"

UCLASS()
class MYGAME_API AMyCharacter : public ACharacter
{
    GENERATED_BODY()

public:
    AMyCharacter();

protected:
    virtual void BeginPlay() override;

public: 
    virtual void Tick(float DeltaTime) override;

    UPROPERTY(EditAnywhere, Category = "Combat")
    float maxDamage;

    void DealMaxDamageToEnemy();
};
UPROPERTY(EditAnywhere, Category = "Combat")
float MaxDamage = 9999.0f;
class AMyCharacter : public ACharacter
{
    GENERATED_BODY()
public:
    virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;
    UFUNCTION()
    void Fire();
    UPROPERTY(EditAnywhere, Category = "Shooting")
    float Accuracy = 0.8f;
private:
    FVector ApplyShotAccuracy(FVector Direction) const;
};
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "MyCharacter.generated.h"

UCLASS()
class YOURGAME_API AMyCharacter : public ACharacter
{
    GENERATED_BODY()
public:
    AMyCharacter();
protected:
    virtual void BeginPlay() override;
public:    
    virtual void Tick(float DeltaTime) override;
    float CalculateDamageWithArmorPenetration(float BaseDamage, float ArmorValue, float ArmorPenetration);
};