#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Weapon.generated.h"

UCLASS()
class YOURGAME_API AWeapon : public AActor
{
    GENERATED_BODY()
public:
    UPROPERTY(EditDefaultsOnly, Category = "Weapon")
    float BulletRangeIncrease = 500.0f;
    UFUNCTION(BlueprintCallable, Category = "Weapon")
    void Fire();
};
UPROPERTY(EditAnywhere, Category = "Weapon Properties")
float MinVerticalRecoil = 0.0f;
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Weapon.generated.h"

UCLASS()
class YOURGAME_API AWeapon : public AActor
{
    GENERATED_BODY()

public:
    AWeapon();

    UPROPERTY(EditAnywhere, Category = "Weapon")
    float AimAccuracyMax;
    void SetAimAccuracyMax(float NewAimAccuracyMax);
};
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Weapon.generated.h"

UCLASS()
class YOURGAME_API AWeapon : public AActor
{
    GENERATED_BODY()

public:
    AWeapon();

    UPROPERTY(EditAnywhere, Category = "Weapon")
    float ReloadTime;

    UPROPERTY(EditAnywhere, Category = "Weapon")
    int32 MaxAmmo;

    UPROPERTY(VisibleAnywhere, Category = "Weapon")
    int32 CurrentAmmo;

    UFUNCTION(BlueprintCallable, Category = "Weapon")
    void Reload();

protected:
    virtual void BeginPlay() override;

private:
    bool bIsReloading;
    FTimerHandle ReloadTimerHandle;

    void FinishReload();

};
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Weapon.generated.h"

UCLASS()
class YOURGAME_API AWeapon : public AActor
{
    GENERATED_BODY()

public:
    AWeapon();

    UPROPERTY(EditAnywhere, Category = "Weapon")
    float BulletSpeed = MAX_FLT;
    protected:
    virtual void BeginPlay() override;

public: 
    virtual void Tick(float DeltaTime) override;
};
UPROPERTY(EditAnywhere, Category = "AimDownSights")
float MaxAimDownSightsFOV = 70.f;
UPROPERTY(EditAnywhere, Category = "Weapon")
float RecoilStrength = 1.0f;
#include "GameFramework/Weapon.h"

void AWeapon::SetMaxAimSpreadDecreaseSpeed(float NewSpeed)
{
    MaxAimSpreadDecreaseSpeed = NewSpeed;
}
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Weapon.generated.h"

UCLASS()
class YOURGAME_API AWeapon : public AActor
{
	GENERATED_BODY()

public:	
	AWeapon();

protected:
	UPROPERTY(EditDefaultsOnly, Category = "Weapon")
	float HorizontalRecoilReductionMultiplier;
	virtual void BeginPlay() override;

	UFUNCTION(BlueprintCallable, Category = "Weapon")
    void ReduceHorizontalRecoil();
};
#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "Weapon.generated.h"

UCLASS()
class YOURGAME_API AWeapon : public AActor
{
    GENERATED_BODY()

public:
    AWeapon();

    UPROPERTY(EditAnywhere, Category = "Weapon")
    bool bReduceVerticalRecoil;
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Weapon")
float MaxDamage;